#pragma once
#include <window/basemodaldlg.h>
#include <map>
#include <system/Translation.h>
#include "resource.h"

class ChangeLangDlg : public ablib::window::BaseModalDlg{
public:
	ChangeLangDlg(HINSTANCE appint) : BaseModalDlg(appint){}
	~ChangeLangDlg(){}
	ablib::system::Translation::LangInfo Show(ablib::window::Wnd *parent);

private:
	ablib::system::Translation::LangInfo m_langinfo;
	std::map<ablib::string,LANGID> m_name2id;
	bool OnInitDialog(ablib::window::Dialog *wnd);
	bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
};

