#ifndef __ENVCHECK_H__
#define __ENVCHECK_H__

#include <window/basemodaldlg.h>
#include <window/window.h>
#include <window/dialog.h>
#include "resource.h"

class EnvCheck : public ablib::window::BaseModalDlg
{
public:
	EnvCheck(HINSTANCE appint,const std::vector<ablib::string> &envs,const ablib::string &msg) : BaseModalDlg(appint),m_envs(envs),m_msg(msg){}
	~EnvCheck(){}
	bool Create(ablib::window::Wnd *wnd){return BaseModalDlg::Create(wnd,IDD_ENVCHECK) != FALSE;}
	bool CheckEnv();

private:
	bool OnInitDialog(ablib::window::Dialog *wnd);
	bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
	void DeleteEnvForced(const TCHAR *env);
	
	std::vector<ablib::string> m_envs;
	ablib::string m_msg;
};

#endif //__ENVECHECK_H__

