#include "stdafx.h"
#include "setting.h"

extern setting g_setting;
static ablib::string tmp_string;

#include "ziptool.h"

/**
* zip`̃t@C𓀂D
* @param file 𓀂t@C
* @param targetdir 𓀐fBNgD
* @return trueCsfalseD
*/
EXPORT bool ZIP(const TCHAR *file,const TCHAR *targetdir){
	return ziptool::DeCompress(file,targetdir);
}

/**
* zip`̃t@C𓀂D_CAO\D
* @param hwnd eEBhEnh
* @param file 𓀂t@C
* @param targetdir 𓀐fBNgD
* @return trueCsfalseD
*/
EXPORT bool ZIPDLG(HWND hwnd,const TCHAR *file,const TCHAR *targetdir){
	ablib::window::Window w(hwnd);
	ziptool z(ablib::system::Translation::GetResourceHandle());
	return z.DeCompresDlg(&w,file,targetdir);
}


#include <Oniguruma/RegEx.h>
#include <memory>
std::vector<std::shared_ptr<Oniguruma::RegEx> > g_RegEx;

template<typename T> inline void CHECK_CLASS(T *&t){if(t == NULL)t = new T();}
inline std::shared_ptr<Oniguruma::RegEx> GET_REGEX(int handle){
	if(handle < 0 || handle >= g_RegEx.size())return std::shared_ptr<Oniguruma::RegEx>();
	else return g_RegEx[handle];
} 


/** K\RpCDRuby݊̐K\gD
* @param reg K\
* @return ΐK\̃nhCs-1D
*/
EXPORT int REGEX_COMPILE(const TCHAR *reg){
	std::shared_ptr<Oniguruma::RegEx> r(new Oniguruma::RegEx());
	if(!r->Compile(reg))return -1;
	g_RegEx.push_back(r);
	return g_RegEx.size() - 1;
}

/** K\
* @param handle K\ANZXp̃nhD
* @param str 
* @return }b`trueCȂfalseD
*/
EXPORT int REGEX_MATCH(int handle,const TCHAR *str){
	std::shared_ptr<Oniguruma::RegEx> onig = GET_REGEX(handle);
	return onig.get() ? onig->Match(str) : FALSE;
}

/** }b`
* @param handle K\ANZXp̃nhD
* @param i Ԗڂ̕񂩁D-1ƑSD
* @return iԖڂ̕
*/
EXPORT const TCHAR *REGEX_GETMATCHSTR(int handle,int i){
	std::shared_ptr<Oniguruma::RegEx> onig = GET_REGEX(handle);
	return onig.get() ? onig->GetMatchStr(i) : FALSE;
}

/** \0ƂϊAD
* @param handle K\ANZXp̃nhD
* @param s \0ƂĂ镶
* @return ϊ̕
*/
EXPORT const TCHAR *REGEX_STR2STR(int handle,const TCHAR *s){
	std::shared_ptr<Oniguruma::RegEx> onig = GET_REGEX(handle);
	return onig.get() ? onig->GetMatchStr(s) : FALSE;
}

/** }b`񒷂擾D
* @param handle K\ANZXp̃nhD
* @return 
*/
EXPORT int REGEX_GETMATCHLEN(int handle){
	std::shared_ptr<Oniguruma::RegEx> onig = GET_REGEX(handle);
	return onig.get() ? onig->GetMatchLen() : FALSE;
}

/** }b`ʒu擾D
* @param handle K\ANZXp̃nhD
* @return }b`ʒuibytePʁj
*/
EXPORT int REGEX_GETMATCHPOS(int handle){
	std::shared_ptr<Oniguruma::RegEx> onig = GET_REGEX(handle);
	return onig.get() ? onig->GetMatchPos() : FALSE;
}


#include "Tar.h"
Tar *g_Tar;

/** tar𓀂g邩ǂDtar32.dllgCtexinsttar.exeg邪C
* tar32.dlltar.exeȂꍇkakuto3p𓀂͎gȂD
* @return gȂtrueCgȂȂfalseD
*/
EXPORT bool ISTARAVAILABLE(){
	if(!g_Tar)g_Tar = new Tar(ablib::system::Translation::GetResourceHandle());
	return g_Tar->IsAvailable();
}

/** tar𓀂D
* @param hwnd eEBhẼEBhEnh
* @param file 𓀂t@CD
* @param targetdir 𓀐
* @return trueCsfalseD
*/
EXPORT bool TARDLG(HWND hwnd,const TCHAR *file,const TCHAR *targetdir){
	if(!g_Tar)g_Tar = new Tar(ablib::system::Translation::GetResourceHandle());
	ablib::window::Wnd w(hwnd);
	return g_Tar->Exec(&w,file,targetdir);
}

#include "Encode.h"

/** R[hECU-JPShift_JISɕϊD
* @param data EUC
* @param size 񒷂DI[NULL͓ȂD
* @return ϊꂽ
*/
EXPORT const char *EUC2SJIS(const BYTE *data,size_type size){
	return Encode::EUC2SJIS(data,size);
}

/** R[hJISShift_JISɕϊD
* @param data JIS
* @param size 񒷂DI[NULL͓ȂD
* @return ϊꂽ
*/
EXPORT const char *JIS2SJIS(const BYTE *data,size_type size){
	return Encode::JIS2SJIS(data,size);
}


#include  "GetDir.h"

/** fBNg[Uɓ͂_CAOoD
* @param hwnd eEBhẼEBhEnh
* @param title EBhEɕ\^Cg
* @param def ŏɕ\fBNg
* @return sLZꂽꍇNULLCłȂΓ͂ꂽD
*/
EXPORT const TCHAR *DIRINPUT(HWND hwnd,const TCHAR *title,const TCHAR *def){
	tmp_string = def;
	static GetDir g(ablib::system::Translation::GetResourceHandle());
	ablib::window::Wnd w(hwnd);
	if(!g.Create(&w,title,tmp_string))return NULL;
	else return tmp_string.c_str();
}

#include "SetEnv.h"

/** VXeϐݒ肷D
* @param name ݒ肷ϐ
* @param value ݒ肷l
* @return trueCsfalseD
*/
EXPORT bool SETSYSTEMENV(const TCHAR *name,const TCHAR *value){
	return SetEnv::SetSystem(name,value);
}

/** [Uϐݒ肷D
* @param name ݒ肷ϐ
* @param value ݒ肷l
* @return trueCsfalseD
*/
EXPORT bool SETUSERENV(const TCHAR *name,const TCHAR *value){
	return SetEnv::SetUser(name,value);
}

/** t@CۑĂfBNg擾D
* @return ۑĂfBNg
*/
EXPORT const TCHAR *GETHOZONDIR(){
	return g_setting.GetHozonDir();
}

/** CXg[fBNg擾D
* @return CXg[fBNg
*/
EXPORT const TCHAR *GETINSTALLDIR(){
	return g_setting.GetInstallDir();
}

/** [U̐ݒ肵proxỹT[o擾
* @return proxyT[o
*/
EXPORT const TCHAR *GETPROXY(){
	return g_setting.GetProxy();
}

/** [U̐ݒ肵proxỹ|[gԍ擾
* @return proxyԍ
*/
EXPORT int GETPORT(){
	return g_setting.GetPortNum();
}

/** lbg[NgݒɂȂĂ邩D
* @return gȂtrueD
*/
EXPORT bool USESNETWORK(){
	return g_setting.IsUseNetwork();
}


EXPORT bool WRITESINI(){
	return g_setting.IsWriteINI();
}



