#include "stdafx.h"
#include <system/System.h>
#include "resource.h"
#include "ExtTeXSet.h"
#include "setting.h"

extern setting g_setting;

bool ExtTeXSet::Create(ablib::window::Wnd *parent){
	return BaseModalDlg::Create(parent,IDD_EXTTEXSET) != FALSE;
}

bool ExtTeXSet::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::CheckBox(wnd,IDC_OTF).SetCheck(g_setting.GetListUpFile(_T("otf")));
	ablib::window::CheckBox(wnd,IDC_OTFDEVEL).SetCheck(g_setting.GetListUpFile(_T("otfdevel")));
	ablib::window::CheckBox(wnd,IDC_OTFBETA).SetCheck(g_setting.GetListUpFile(_T("otfbeta")));
	ablib::window::CheckBox(wnd,IDC_LUATEX).SetCheck(g_setting.GetListUpFile(_T("luatex")));
	ablib::window::CheckBox(wnd,IDC_LUATEXDEV).SetCheck(g_setting.GetListUpFile(_T("luatex-dev")));
	if(ablib::system::System().Is64bit()){
		ablib::window::CheckBox(wnd,IDC_LUATEXW64).SetCheck(g_setting.GetListUpFile(_T("luatex-w64")));
		ablib::window::CheckBox(wnd,IDC_LUATEXW64DEV).SetCheck(g_setting.GetListUpFile(_T("luatex-w64-dev")));
	}else{
		ablib::window::CheckBox(wnd,IDC_LUATEXW64).ShowWindow(ablib::window::Wnd::sw_hide);
		ablib::window::CheckBox(wnd,IDC_LUATEXW64).Enabled(FALSE);
		ablib::window::CheckBox(wnd,IDC_LUATEXW64DEV).ShowWindow(ablib::window::Wnd::sw_hide);
		ablib::window::CheckBox(wnd,IDC_LUATEXW64DEV).Enabled(FALSE);
	}
//	ablib::window::CheckBox(wnd,IDC_XETEX).SetCheck(g_setting.GetListUpFile(_T("xetex")));
//	ablib::window::CheckBox(wnd,IDC_XETEXDEV).SetCheck(g_setting.GetListUpFile(_T("xetex-dev")));

	return true;
}

bool ExtTeXSet::OnCommand(ablib::window::Dialog *wnd, int id, int parem){
	switch(id){
	case IDOK:
		g_setting.SetListUpFile(_T("otf"),ablib::window::CheckBox(wnd,IDC_OTF).GetCheck());
		g_setting.SetListUpFile(_T("otfdevel"),ablib::window::CheckBox(wnd,IDC_OTFDEVEL).GetCheck());
		g_setting.SetListUpFile(_T("otfbeta"),ablib::window::CheckBox(wnd,IDC_OTFBETA).GetCheck());
		g_setting.SetListUpFile(_T("luatex"),ablib::window::CheckBox(wnd,IDC_LUATEX).GetCheck());
		g_setting.SetListUpFile(_T("luatex-dev"),ablib::window::CheckBox(wnd,IDC_LUATEXDEV).GetCheck());
		if(ablib::system::System().Is64bit()){
			g_setting.SetListUpFile(_T("luatex-w64"),ablib::window::CheckBox(wnd,IDC_LUATEXW64).GetCheck());
			g_setting.SetListUpFile(_T("luatex-w64-dev"),ablib::window::CheckBox(wnd,IDC_LUATEXW64DEV).GetCheck());
		}
//		g_setting.SetListUpFile(_T("xetex"),ablib::window::CheckBox(wnd,IDC_XETEX).GetCheck());
//		g_setting.SetListUpFile(_T("xetex-dev"),ablib::window::CheckBox(wnd,IDC_XETEXDEV).GetCheck());
		wnd->Destroy(0);
		return true;
	case IDCANCEL:
		wnd->Destroy(0);
		return true;
	default:
		return false;
	}
}


