#include "stdafx.h"
#include <system/System.h>
#include "File.h"


bool File::GetProgramFolder(TCHAR *buf){
	LPITEMIDLIST id;
	LPMALLOC mal;
	if(FAILED(::SHGetMalloc(&mal)))return false;
	if(FAILED(::SHGetSpecialFolderLocation(NULL,CSIDL_PROGRAMS, &id)))return false;
	if(!::SHGetPathFromIDList(id,buf))return false;
	mal->Free(id);
	if(buf[::lstrlen(buf) - 1] != '\\')::lstrcat(buf,_T("\\"));
	return true;
}

void File::DeleteFiles(const TCHAR *dir){
	WIN32_FIND_DATA wfd;
	HANDLE hFind;
	ablib::string pattern = dir;
	ablib::string d = dir;
	pattern += _T("*.*");
	hFind = ::FindFirstFile(pattern.c_str(),&wfd);
	do{
		if(::lstrcmp(wfd.cFileName,_T(".")) == 0 || ::lstrcmp(wfd.cFileName,_T("..")) == 0)continue;
		d = dir;
		d += wfd.cFileName;
		if(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			d += _T("\\");
			File::DeleteFiles(d.c_str());
		}else ::DeleteFile(d.c_str());
	}while(::FindNextFile(hFind,&wfd));

	d = dir;
	d.erase(d.length() - 1);
	::FindClose(hFind);
	::RemoveDirectory(d.c_str());
	return;
}

