#ifndef __INSTALL_H__
#define __INSTALL_H__

#include <vector>
#include <window/basemodaldlg.h>
#include <window/Window.h>
#include <functional>
#include "Plugin.h"

/*
et@C̃CXg[Dcase by caseȂD
*/

class Install : public ablib::window::BaseModalDlg{
public:
	Install(HINSTANCE appint) : BaseModalDlg(appint),m_appint(appint){}
	~Install(){}
	int Show(ablib::window::Wnd *parent);

	static bool Exec(const TCHAR *cmd,const TCHAR *curdir,int &errleve,ablib::basic_string<char> &outstr,bool show = true);

private:
	bool m_isabort;
	ablib::string m_msg;
	HINSTANCE m_appint;
	ablib::window::Wnd *m_parent;
	std::vector<ablib::string> m_w32texuninstalledfile;

	bool CheckCancel(){return GetWindow()->SendMsg(WM_ISCANCEL,0,0) != FALSE;}

	bool OnInitDialog(ablib::window::Dialog *wnd);
	bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
	INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam);
	std::vector<ablib::string> m_w32texfiles;
//	void CopyW32TeXFiles();
//	void DeleteW32TeXFiles();

	bool W32TeXInstall();
	bool W32TeXUnInstall(const ablib::string &f);
	bool W32TeXCheckUnInstall(const ablib::string &f,std::vector<ablib::string> &uninstfile);

	bool DVIOUTInstall(const ablib::string &dviout);
	bool DVIOUTSetting();
//	static BOOL CALLBACK SearchDVIOUTWndProc(HWND hWnd, LPARAM lParam);
	bool DVIOUTUnInstall();
	bool CheckDVIOUTInstall();

	bool GSInstall(const ablib::string &gs);
	bool GSSetting();
	bool GSUnInstall();
	bool CheckGSInstall();

	/*
	bool GVInstall(const ablib::string &gv);
	bool GVUnInstall();
	bool CheckGVInstall();
	*/

	ablib::string ExecToPath(const ablib::string &exec);

	ablib::string SearchGSDir(ablib::string &dir);
	ablib::string GetGSDir();
	ablib::string m_gsdir;
	ablib::string GetEnv(const TCHAR *path);
//	void OpenDVIOUTtxt();
	bool CheckandSetTmp(const TCHAR *dir);
	bool CheckandSetTmpEnv(const TCHAR *env,const TCHAR *dir);

	int StartInstall();

	bool Updatelsr();

	void WriteMsg(const ablib::string &msg);
	void AddMsg(const ablib::string &msg);
	ablib::string GetMsg();

	struct TEXVAR{
	public:
		TEXVAR(const TCHAR *varname);
		~TEXVAR(){}
		ablib::string Get() const{return m_var;}
	private:
		static std::map<ablib::string,ablib::string> m_texvars;
		ablib::string m_var;
		static ablib::string defaultvar(const TCHAR *var);
	};
};

#endif //__INSTALL_H__

