#ifndef __INSTALLFILES_H__
#define __INSTALLFILES_H__

#include <vector>
#include <map>
#include <system/Time.h>
#include "kakuto3.h"

/** t@CǗD
* lbg[Nɂt@CƂ̃TCY͂C
* ÕCXg[ǂ܂Ői񂾂ƁCidownload\filelist\filestate.inij
* ݂̃CXg[ԁidownload\filelist\*.txtj
* ƂۑD
*/

class InstallFiles
{
public:
	struct FileData{
		ablib::string file;
		int size;
		ablib::system::Time time;
	};
	struct FileInfo{
		FileInfo() : state_download(not_done),state_install(not_done),todo_download(false),todo_install(false){}
		State state_download,state_install;
		bool todo_download,todo_install;
		int size;// lbgɂt@C̃TCY
		ablib::system::Time time;
		
	};
	typedef std::map<ablib::string,FileInfo> Filelist;
	InstallFiles() : m_mktexlsr(false),m_reboot(false){}
	~InstallFiles(){}
	// installt@C = _E[ht@C
	//    i Or߂ɂȂĂȂj
	// ȂtrueԂ
	bool Set(
		const std::vector<FileData> &w32texnetfiles,
		const std::vector<FileData> &dvioutnetfiles,
		const std::vector<FileData> &gsnetfiles//,
//		const std::vector<FileData> &gvnetfiles
	);
	void Save();
	bool SetDownload(const ablib::string &f,bool check);
	bool SetDownloadState(const ablib::string &f,State state);
	bool SetInstall(const ablib::string &f,bool check);
	bool SetInstallState(const ablib::string &f,State state);

	void Settexinst(const ablib::string &tinst){m_texinst = tinst;}
	ablib::string Gettexinst() const{return m_texinst;}

	const Filelist &GetW32TeXFileInfo() const{return m_w32tex;}
	const Filelist &GetdvioutFileInfo() const{return m_dviout;}
	const Filelist &GetGSFileInfo() const{return m_gs;}
	const Filelist &GetGVFileInfo() const{return m_gv;}

private:
	std::map<ablib::string,FileInfo> m_w32tex,m_dviout,m_gs,m_gv;
	ablib::string m_texinst;
	int GetIniInt(const ablib::string &file,const ablib::string &sec,const ablib::string &key) const;

	int GetLatest(const std::vector<FileData> &files) const;

public:
	// ̓CXg[Ɋւf[^LD
	void Updatelsr(){m_mktexlsr = true;}
	bool DoesUpdatelsr()const{return m_mktexlsr;}
	void Reboot(){m_reboot =  true;}
	bool DoesReboot()const{return m_reboot;}

private:
	bool m_mktexlsr,m_reboot;
};

#endif //__INSTALLFILES_H__
