#include "stdafx.h"
#include <system/System.h>
#include "Path.h"
#include "Setting.h"
#include "func.h"
#include "Registory.h"
#include "InstallFiles.h"

extern setting g_setting;
extern InstallFiles g_InstallFiles;

extern struct Report {
	ablib::string tex;
	ablib::string dviout;
	ablib::string dvioutset;
	ablib::string gs;
	//ablib::string gv;
	ablib::string gsset;
	ablib::string envset;
	ablib::string plugin;
}g_report;

ablib::string Path::GetEnv(const TCHAR *env){
	DWORD size = ::GetEnvironmentVariable(env,NULL,0);
	if(size == 0)return _T("");
	++size;
	TCHAR *s = new TCHAR[size];
	::GetEnvironmentVariable(env,s,size);
	ablib::string rv = s;
	delete[] s;
	return rv;
}

bool Path::SetPath(){
//	m_msg += _T("ϐ̒ǉcc");
//	WriteMsg(m_msg);
//	g_setting.Log(_T("ϐPATH̒ǉJn"));
	g_report.envset = _TR("sv");
	bool rv = true;

	std::vector<ablib::string> addpath,delpath,delpathtmp;
	// ԂĂ镪
	for(ablib::string &i : m_deletepath){
		bool exist = false;
		for(ablib::string &j : delpathtmp){
			if(CheckSameFile(i.c_str(),j.c_str())){
				exist = true;
				break;
			}
		}
		if(!exist)delpathtmp.push_back(i);
	}
	for(ablib::string &i : m_addpath){
		bool exist = false;
		for(ablib::string &j : addpath){
			if(CheckSameFile(i.c_str(),j.c_str())){
				exist = true;
				break;
			}
		}
		if(!exist)addpath.push_back(i);
	}


	// ēCł͒PȂoJ
	for(ablib::string &i : delpathtmp){
		bool addexist = false;
		for(ablib::string &j : addpath){
			if(CheckSameFile(i.c_str(),j.c_str())){
				addexist = true;
				break;
			}
		}
		if(!addexist)delpath.push_back(i);
	}

	ablib::system::System sys;

	if(sys.IsNT()){
		TCHAR RegPath[] = _T("SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment");
		// PATH擾D
		ablib::string nowpath;
		if(!Registory::ReadSZ(HKEY_LOCAL_MACHINE,RegPath,_T("PATH"),nowpath)){
			g_setting.Log(_TR("WXgJ܂ł"));
//			m_msg += _T("s\r\n");WriteMsg(m_msg);
			g_report.envset = _TR("s");rv = false;
			g_setting.Log(_TR("ϐǉs"));
		}
		bool change = false;
		if(nowpath != _T("") && nowpath[nowpath.length() - 1] == ';')nowpath.erase(nowpath.length() - 1);
		std::vector<ablib::string> nowpaths;
		// PATH؂蕪Ċi[D
		ablib::string::size_type p = 0,q = 0;
		while(true){
			p = nowpath.find(_T(";"),q);
			nowpaths.push_back(nowpath.substr(q,p - q));
			if(p == ablib::string::npos)break;
			q = p + 1;
		}
//		g_setting.Log(_T("݂PATH"));
//		g_setting.Log(nowpath);
		// 폜PATHčsD
		std::vector<ablib::string> paths;
		for(ablib::string &i : nowpaths){
			bool del = false;
			for(ablib::string &j : delpath){
				if(CheckSameFile(i.c_str(),j.c_str())){
					del = true;
					g_InstallFiles.Reboot();change = true;
					g_setting.Log(ablib::string::sprintf(_TR("ϐPATHu%sv폜"),i.c_str()));
					break;
				}
			}
			if(!del)paths.push_back(i);
		}
		// ׂPATHǉD
		for(ablib::string &i : addpath){
			bool exist = false;
			for(ablib::string &j : paths){
				if(CheckSameFile(i.c_str(),j.c_str())){
					exist = true;
					break;
				}
			}
			if(!exist){
				paths.push_back(i);
				g_InstallFiles.Reboot();change = true;
				g_setting.Log(ablib::string::sprintf(_TR("ϐPATHɁu%svǉ"),i.c_str()));
			}
		}

		if(change){
			// PATH񐶐
			ablib::string path;
			for(ablib::string &i : paths)path += i + _T(";");
			// ϐREG_EXPAND_SZ^DmkasathanksI
			if(!Registory::WriteSZ(HKEY_LOCAL_MACHINE,RegPath,_T("PATH"),path.c_str(),true)){
				g_setting.Log(_TR("WXgւ̏ݎs"));
//				m_msg += _T("s\r\n");WriteMsg(m_msg);
				g_report.envset = _TR("s");rv = false;
				g_setting.Log(_TR("ϐ̏Ɏs"));
			}
//			m_msg += _T("\r\n");
			g_report.envset = _TR("");
//			WriteMsg(m_msg);
			DWORD ret;
			::SendMessageTimeout(
				HWND_BROADCAST,
				WM_SETTINGCHANGE,
				0,
				reinterpret_cast<LPARAM>(_T("Environment")),
				SMTO_ABORTIFHUNG,
				5000,
				&ret);
			::SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, 0, 0);
		}else{
			g_setting.Log(_TR("ϐPATHKv͂܂ł"));
//			m_msg += _T("sv\r\n");
			g_report.envset = _TR("sv");
//			WriteMsg(m_msg);
		}
	}else{
		// ̂Ƃ9xn͊ϐ폜̓T|[gŁccD
		ablib::string nowpath = GetEnv(_T("PATH"));
		if(nowpath != _T("") && nowpath[nowpath.length() - 1] == ';')nowpath.erase(nowpath.length() - 1);
		std::vector<ablib::string> nowpaths;
		// PATH؂蕪Ċi[D
		ablib::string::size_type p = 0,q = 0;
		while(true){
			p = nowpath.find(_T(";"),q);
			nowpaths.push_back(nowpath.substr(q,p - q));
			if(p == ablib::string::npos)break;
			q = p + 1;
		}

		ablib::string add = _T("set PATH=\"%PATH%\"");
		ablib::string path = _T("");
		for(ablib::string &i : addpath){
			bool exist = false;
			for(ablib::string &j : nowpaths){
				if(CheckSameFile(i.c_str(),j.c_str())){
					exist = true;
					break;
				}
			}
			if(!exist)path += _T(";") + i;
		}
		if(path != _T("")){
			TCHAR buf[128];::GetSystemDirectory(buf,127);
			ablib::string autoexec = buf[0];
			autoexec += _T(":\\autoexec.bat");
			FILE *fp = ::_tfopen(autoexec.c_str(),_T("a+"));
			if(fp){
				::_ftprintf(fp,_T("\n%s%s\n"),add.c_str(),path.c_str());
				::fclose(fp);
//				m_msg += _T("ϐPATH") + path + _T("ǉcc\r\n");
				g_setting.Log(ablib::string::sprintf(_TR("ϐPATHɁu%svǉ"),path.c_str()));
				g_InstallFiles.Reboot();
				g_report.envset = _TR("");
			}else{
				g_setting.Log(ablib::string::sprintf(_TR("ϐPATHɁu%svǉ悤Ƃ玸s"),path.c_str()));
//				m_msg += _T("ϐPATH") + path + _T("ǉccs\r\n");
				g_report.envset = _TR("s");
			}
//			WriteMsg(m_msg);
		}
	}

//	g_setting.Log(_T("ϐPATH̒ǉI"));
	return rv;
}

