#ifndef __PLUGIN_H__
#define __PLUGIN_H__

#include <vector>
#include <window/PropSheet.h>
#include "PluginInterface.h"

/** ߂ǂȂ̂ŁiHjĈ̓vOCɂႢ܂D
* 
* t@C̃vOCŃT|[gĂĂC
* ̃NX̊O͂̈Ⴂ͂킩Ȃ悤ɂD
* PluginData̓\tg̃f[^ĂD
* plugino͓vOCł͓̂gD
* 
* vOCłCindexnƂŃ\tgύXD
* vOCgɓn͕̂񂾂C
* ̕ϊPluginInterfaceipNXjsD
* ACGetDownloadDataƂindexgȂ֐́C
* 񂾂Ăяo΂̂ŁCindex = 0ł̂݌ĂяoD
*/

class Plugin{
public:
	Plugin(){}
	const TCHAR *Info(int index){return m_plugindata[index].plugin->Info(m_plugindata[index].index);}
	const TCHAR *SoftName(int index){return m_plugindata[index].plugin->SoftName(m_plugindata[index].index);}
	bool Sets(int index){return m_plugindata[index].plugin->Sets(m_plugindata[index].index);}
	void Set(HWND hwnd,int index){return m_plugindata[index].plugin->Set(hwnd,m_plugindata[index].index);}
	bool GetInfo(HWND hwnd);
	bool IsDefault(int index){return m_plugindata[index].plugin->IsDefault(m_plugindata[index].index);}
	bool GetDownloadList(std::vector<ablib::string> &urls,std::vector<ablib::string> &files,std::vector<size_type> &sizes);
	bool Install(HWND hwnd);
	bool Reboots();
	void UnInit();
	int GetPluginNum(){return m_plugindata.size();}
	void SetDL(int index,bool b){m_plugindata[index].isinstall = b;}
	bool IsInstall(int index){return m_plugindata[index].isinstall;}
	void SetDownloadState(const ablib::string &url,PluginInterface::State state){m_downloadstate[url] = state;}

	void Load();
	void UnLoad();

	void AddPlugin(PluginInterface *plugin);

private:
	struct PluginData{
		PluginInterface *plugin;
		int index;
		bool isinstall;
	};
	std::vector<PluginData> m_plugindata;
	
	bool SetPlugin(PluginInterface *plugin,const TCHAR *file);
	std::map<ablib::string,PluginInterface::State> m_downloadstate;

	
};

#endif //__PLUGIN_H__

