#ifndef __PLUGININTERFACE_H__
#define __PLUGININTERFACE_H__


#include <map>
#include "kakuto3.h"

/**
* vOC̃C^[tF[XD|mtBYgKR邩͕sD
*/

class PluginInterface{
public:
	struct PluginInfo{
		ablib::string softname;// CXg[\tg
		ablib::string info;// vOC̐
	};

	struct DLFile{
		ablib::string url;// _E[hURL
		ablib::string file;// _E[ht@CD
		size_type size;// _E[ht@C̃TCYîł悢j
	};

	struct DownloadData{
		bool success;//擾ɐǂD
		int downnum;//_E[ht@C̐
		std::vector<DLFile> dls;//e_E[h̃f[^
	};

	typedef ::State State;
	struct DLResult{
		int size;
		struct Result{
			ablib::string url;
			State state;
		};
		std::vector<Result> results;
	};


	PluginInterface(void){}
	~PluginInterface(void){}

	virtual bool Load(const TCHAR *file) = 0;
	virtual bool UnLoad() = 0;
	virtual const TCHAR *PluginFile() = 0;
	virtual const TCHAR *Info(int index) = 0;
	virtual const TCHAR *SoftName(int index) = 0;
	virtual void Set(HWND hwnd,int index) = 0;
	virtual bool GetInfo(HWND hwnd) = 0;
	virtual bool IsDefault(int index) = 0;
	virtual PluginInterface::DownloadData GetDownloadData(int index) = 0;
	virtual bool Install(HWND hwnd,int index,const std::map<ablib::string,State> &dlstate) = 0;
	virtual bool Sets(int index) = 0;
	virtual bool Reboots() = 0;
	virtual void UnInit() = 0;

	virtual int GetSoftNum() = 0;
};

#endif //__PLUGININTERFACE_H__

