#ifndef __RUBYPLUGIN_H__
#define __RUBYPLUGIN_H__

#include <vector>
#include <ruby.h>
#include "PluginInterface.h"

class RubyPlugin : public PluginInterface{
public:
	RubyPlugin(){m_downloaddata.downnum = 0;}
	~RubyPlugin(){}

	// t@CǂݍށD`̓ǂݍ݂ɂCt@ĈvOCƔFꂽ
	// trueԂD
	// register_pluginœǂݍ܂ꂽꍇfalseԂD
	bool Load(const TCHAR *file);
	bool Load(const ablib::string &name,const ablib::string &file,VALUE mod);
	bool UnLoad(){return true;}
	const TCHAR *PluginFile(){return m_filename.c_str();}
	const TCHAR *Info(int index){return m_infos[index].info.c_str();}
	const TCHAR *SoftName(int index){return m_infos[index].softname.c_str();}
	void Set(HWND hwnd,int index);
	bool GetInfo(HWND hwnd);
	bool IsDefault(int index);
	PluginInterface::DownloadData GetDownloadData(int index);
	bool Install(HWND hwnd,int index,const std::map<ablib::string,State> &dlstates);
	bool Sets(int index);
	bool Reboots();
	void UnInit();

	int GetSoftNum(){return m_infos.size();}
	
	void AddPlugin(PluginInterface *plugin);


private:
	ablib::string m_modulename,m_filename;
	VALUE m_module;

	bool InitializePlugin();

	DownloadData m_downloaddata;

	struct SoftInfo{
		SoftInfo(const TCHAR *s,const TCHAR *i) : softname(s),info(i){}
		SoftInfo(const ablib::string &s,const ablib::string &i) : softname(s),info(i){}
		ablib::string softname,info;
	};
	std::vector<SoftInfo> m_infos;
	void WriteExceptionLog(const ablib::string &func);
	static VALUE sGetLastError(VALUE module);

	static VALUE sInfo(VALUE module);
//	struct InitArg{VALUE module;VALUE ini;VALUE log;};
	static VALUE sInit(VALUE val);
//	struct SetArg{VALUE module;VALUE hwnd;VALUE index;};
	static VALUE sSet(VALUE val);
//	struct GetInfoArg{VALUE module;VALUE hwnd;};
	static VALUE sGetInfo(VALUE val);
//	struct IsDefaultArg{VALUE module;VALUE index;};
	static VALUE sIsDefault(VALUE val);
//	struct GetDownloadDataArg{VALUE module;VALUE index;};
	static VALUE sGetDownloadData(VALUE module);
//	struct InstallArg{VALUE module;VALUE hwnd;VALUE index;VALUE dlstates;};
	static VALUE sInstall(VALUE val);
//	struct SetsArg{VALUE module;VALUE index;};
	static VALUE sSets(VALUE val);
	static VALUE sReboots(VALUE module);
	static VALUE sUnInit(VALUE module);

};

#endif //__RUBYPLUGIN_H__

