# -*- encoding: Shift_JIS -*-

require 'Win32API'

module AbTeXinst
	@plugins = [];

	def get_specialfolder(type)
		print "AbTeXinst::get_specialfolder : {ȂKȃtH_Ԃ܂D\n"
		return "."
	end
	module_function :get_specialfolder

	def zip(file,dir)
		print "AbTeXinst::zip : {Ȃ\n#{file}\n\n#{dir}\nɉ𓀂܂D\n"
		return true
	end
	module_function :zip
	
	
	def zipdlg(hwnd,file,dir)
		print "AbTeXinst::zipdlg : {Ȃ\n#{file}\n\n#{dir}\nɃ_CAO\\ĉ𓀂܂D\n"
		return true
	end
	module_function :zipdlg
	
	
	def tar_available?
		print "AbTeXinst::tar_avilable? : Tar͎gƂƂɂ܂D\n"
		return true
	end
	module_function :tar_available?
	
	
	def tardlg(hwnd,file,dir)
		print "AbTeXinst::tardlg : {Ȃ\n#{file}\n\n#{dir}\nɃ_CAO\\ĉ𓀂܂D\n"
		return true
	end
	module_function :tardlg
	
	
	def dir_input(hwnd,title,defn)
		print "AbTeXinst::dir_input : {Ȃ^Cg\n#{title}\n\\āCftHg\n#{defn}\nŃfBNg͂܂D\n"
		return true
	end
	module_function :dir_input
	
	
	def set_systemenv(name,val)
		print "AbTeXinst::set_systemenv : VXeϐ\n#{name} = #{val}\nŐݒ肵܂D\n"
		return true
	end
	module_function :set_systemenv
	
	
	def set_userenv(name,val)
		print "AbTeXinst::set_userenv : [Uϐ\n#{name} = #{val}\nŐݒ肵܂D\n"
		return true
	end
	module_function :set_userenv
	
	
	def set_message(hwnd,str)
		print "AbTeXinst::set_message : #{str}\n"
		return true
	end
	module_function :set_message
	
	
	def add_message(hwnd,str)
		print "AbTeXinst::add_message : #{str}\n"
		return true
	end
	module_function :add_message
	
	
	def cancel?(hwnd)
		print "Kakuoto3::cancel?\n"
		return false
	end
	module_function :cancel?
	
	def write_ini_str(file,sec,key,str)
		print "AbTeXinst::write_ini_str : #{file}#{sec}C#{key}#{str}݁D\n"
		api = Win32API.new('kernel32','WritePrivateProfileString',%w(p p p p),'i')
		
		return api.call(sec,key,str,file);
	end
	module_function :write_ini_str
	
	def write_ini_int(file,sec,key,val)
		print "AbTeXinst::write_ini_int : #{file}#{sec}C#{key}#{val}݁D\n"
		api = Win32API.new('kernel32','WritePrivateProfileString',%w(p p p p),'i')
		
		return api.call(sec,key,String(str),file);
	end
	module_function :write_ini_int
	
	def get_ini_str(file,sec,key)
		print "AbTeXinst::get_ini_str : #{file}#{sec}C#{key}ǂݏoD\n"
		api = Win32API.new('kernel32','GetPrivateProfileString',%w(p p p p i p),'i');
		rv = "\0" * 4096;
		api.call(sec,key,"",rv,4095,file);
		rv.gsub!(/\0/,"")
		print "ĺu" + rv + "v\n"
		return rv
	end
	module_function :get_ini_str
	
	def get_ini_int(file,sec,key)
		print "AbTeXinst::get_ini_int : #{file}#{sec}C#{key}ǂݏoD\n"
		api = Win32API.new('kernel32','GetPrivateProfileInt',%w(p p i p),'i');
		rv = api.call(sec,key,0,file)
		print "ĺu" + String(rv) + "v\n"
		return rv
	end
	module_function :get_ini_int
	
	def add_path(path)
		print "AbTeXinst::add_path : {ȂϐPATH" + path + "ǉ܂D\n";
		return true
	end
	module_function :add_path
	
	def del_path(path)
		print "AbTeXinst::del_path : {ȂϐPATH" + path + "폜܂D\n";
		return true
	end
	module_function :del_path
	
	def update_lsr()
		print "AbTeXinst::update_lsr : {Ȃls-RiKvȂ΁jXV܂D\n";
		return true;
	end
	
	def get_windowpos(hwnd)
		print "{ȂEBhEnh #{hwnd} ̃EBhẼTCY擾܂D\n";
		return [0,0,0,0];
	end
	module_function :get_windowpos
	
	def sethwndtovrobj(obj,hwnd)
		return obj;
	end
	module_function :sethwndtovrobj

	def register_plugin(name,cls)
		print "vOC#{name}o^\n";
		mod = cls.new;
		@plugins.push([name,mod]);
		return mod;
	end
	module_function :register_plugin
	
	def get_plugins
		return @plugins;
	end
	module_function :get_plugins

	FAILT = 1
	SUCCESS = 2
	CANCEL = 3

	CSIDL_FLAG_CREATE  = 0x8000
	CSIDL_ADMINTOOLS  = 0x0030
	CSIDL_ALTSTARTUP  = 0x001d
	CSIDL_APPDATA  = 0x001a
	CSIDL_BITBUCKET  = 0x000a
	CSIDL_CDBURN_AREA  = 0x003b
	CSIDL_COMMON_ADMINTOOLS  = 0x002f
	CSIDL_COMMON_ALTSTARTUP  = 0x001e
	CSIDL_COMMON_APPDATA  = 0x0023
	CSIDL_COMMON_DESKTOPDIRECTORY  = 0x0019
	CSIDL_COMMON_DOCUMENTS  = 0x002e
	CSIDL_COMMON_FAVORITES  = 0x001f
	CSIDL_COMMON_MUSIC  = 0x0035
	CSIDL_COMMON_PICTURES  = 0x0036
	CSIDL_COMMON_PROGRAMS  = 0x0017
	CSIDL_COMMON_STARTMENU  = 0x0016
	CSIDL_COMMON_STARTUP  = 0x0018
	CSIDL_COMMON_TEMPLATES  = 0x002d
	CSIDL_COMMON_VIDEO  = 0x0037
	CSIDL_COMPUTERSNEARME  = 0x003d
	CSIDL_CONNECTIONS  = 0x0031
	CSIDL_CONTROLS  = 0x0003
	CSIDL_COOKIES  = 0x0021
	CSIDL_DESKTOP  = 0x0000
	CSIDL_DESKTOPDIRECTORY  = 0x0010
	CSIDL_DRIVES  = 0x0011
	CSIDL_FAVORITES  = 0x0006
	CSIDL_FLAG_DONT_VERIFY  = 0x4000
	CSIDL_FONTS  = 0x0014
	CSIDL_HISTORY  = 0x0022
	CSIDL_INTERNET  = 0x0001
	CSIDL_INTERNET_CACHE  = 0x0020
	CSIDL_LOCAL_APPDATA  = 0x001c
	CSIDL_MYDOCUMENTS  = 0x000c
	CSIDL_MYMUSIC  = 0x000d
	CSIDL_MYPICTURES  = 0x0027
	CSIDL_MYVIDEO  = 0x000e
	CSIDL_NETHOOD  = 0x0013
	CSIDL_NETWORK  = 0x0012
	CSIDL_PERSONAL  = 0x0005
	CSIDL_PHOTOALBUMS  = 0x0045
	CSIDL_PLAYLISTS  = 0x003f
	CSIDL_PRINTERS  = 0x0004
	CSIDL_PRINTHOOD  = 0x001b
	CSIDL_PROFILE  = 0x0028
	CSIDL_PROGRAM_FILES  = 0x0026
	CSIDL_PROGRAM_FILES_COMMON  = 0x002b
	CSIDL_PROGRAMS  = 0x0002
	CSIDL_RECENT  = 0x0008
	CSIDL_RESOURCES  = 0x0038
	CSIDL_SAMPLE_MUSIC  = 0x0040
	CSIDL_SAMPLE_PLAYLISTS  = 0x0041
	CSIDL_SAMPLE_PICTURES  = 0x0042
	CSIDL_SAMPLE_VIDEOS  = 0x0043
	CSIDL_SENDTO  = 0x0009
	CSIDL_STARTMENU  = 0x000b
	CSIDL_STARTUP  = 0x0007
	CSIDL_SYSTEM  = 0x0025
	CSIDL_TEMPLATES  = 0x0015
	CSIDL_WINDOWS  = 0x0024

	module Setting
		@@ini = "";
		
		def init(ini,log)
			@@ini = ini;
		end
		module_function :init
		
		def hozon_dir
			print "Setting::hozon_dirF_E[ht@C̕ۑԂ܂D";
			return AbTeXinst::get_ini_str(@@ini,"Dir","Hozon");
		end
		module_function :hozon_dir
		
		def install_dir
			print "Setting::install_dirFCXg[Ԃ܂D";
			return AbTeXinst::get_ini_str(@@ini,"Dir","Install");
		end
		module_function :install_dir
		
		def proxy
			print "Setting::proxyFproxy̏Ԃ܂\n";
			return {"server" => AbTeXinst::get_ini_str(@@ini,"Connect","Proxy"), "port" => AbTeXinst::get_ini_int(@@ini,"Connect","Port")};
		end
		module_function :proxy
		
		def use_network?
			print "Setting::use_network?Flbg[N͎gƂɂ܂D";
			return true;
		end
		module_function :use_network?
		
		def write_ini?
			print "Setting::write_ini?Finiɂ͏ނƂɂ܂D";
			return true;
		end
		module_function :write_ini?
	end

end


