# coding: Shift_JIS

class IPAClass
	def initialize
		@ini = "";@log = "";
		@htmlurl = 'http://ossipedia.ipa.go.jp/ipafont/download.html?ruleagreement=Accept';
		@size = 0;@success = false;@definstall = true;
		@localfile = "ipaex_font.zip";
	end
	
	def info
		return [{"softname" => "IPAex", "info" => "IPAextHgCXg[ + dvipdfmx̃tHgߍݐݒ"}];
	end
	
	def plugin_init(ini,log)
		@ini = ini;@log = log;
	end
	
	def reboot?
		return false;
	end
	
	def set?(soft)
		return false;
	end
	
	def set(hwnd,soft)
		return;
	end
	
	def get_info(hwnd)
		Log("IPAextHg̏擾Jn");
		if !AbTeXinst::Setting::use_network? then
			begin
				@definstall = File.exist?(AbTeXinst::Setting::hozon_dir + @localfile);
			rescue
				@definstall = false;
			end
			return true;
		end
		
			# proxy̐ݒ
		proxy = AbTeXinst::Setting::proxy;
		if proxy == nil then
			proxy = AbTeXinst::get_IEproxy_info;
		end
		if proxy == nil or proxy["server"] == "" then
			proxy = {"server" => nil,"port" => nil};
		end

		uri = URI.parse(@htmlurl)
		if uri.scheme != "http" then
			Log("httpłȂƂ܂D")
			return false;
		end
		AbTeXinst::add_message(hwnd,"\r\n\r\nIPAextHg̏擾Jn\r\n")
		response = nil
		AbTeXinst::add_message(hwnd,"" + uri.host + "ɐڑ擾܂D\r\n");
		Net::HTTP::Proxy(proxy["server"],proxy["port"]).start(uri.host){|http|
			response = http.get(uri.path)
		}
		if response == nil then
			AbTeXinst::add_message(hwnd,"擾Ɏs\r\n")
			Log("擾Ɏs")
			return false
		end
		
		if !(/<a\s*href\s*=\s*"(ipaexfont.*)"\s*>\s*ipaexfont.*?\((.*?)\)\s*</a>/ =~ response.body) then
			AbTeXinst::add_message(hwnd,"IPAextHg̔Ɏs\r\n");
			Log('擾Ɏs');
			return false;
		end
		
		file = Regexp.last_match[1];size = Regexp.last_match[2];

	end
	
	
	
private
	def Log(l)
		begin
			fp = File.open(@log,"a+")
		rescue
			return
		end
		fp.write(l + "\n");
		fp.close()
	end
end

Ipa = IPAClass.new



