#include "stdafx.h"
#include <system/System.h>
#include "Registory.h"
#include "setenv.h"
#include "func.h"

bool SetEnv::SetSystem(const TCHAR *name,const TCHAR *value){
	return ablib::system::System().IsNT() ? SetNTSystem(name,value) : Set98(name,value);
}

bool SetEnv::SetUser(const TCHAR *name,const TCHAR *value){
	return ablib::system::System().IsNT() ? SetNTUser(name,value) : Set98(name,value);
}

bool SetEnv::SetNTSystem(const TCHAR *name,const TCHAR *value){
	TCHAR RegPath[] = _T("SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment");
	return Registory::WriteSZ(HKEY_LOCAL_MACHINE,RegPath,name,value);
}

bool SetEnv::SetNTUser(const TCHAR *name,const TCHAR *value){
//	TCHAR RegPath[] = _T("SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment");
	TCHAR RegPath[] = _T("Environment");
	return Registory::WriteSZ(HKEY_CURRENT_USER,RegPath,name,value);
}


bool SetEnv::Set98(const TCHAR *name,const TCHAR *value){
	TCHAR buf[128];::GetSystemDirectory(buf,127);
	ablib::string autoexec = buf[0];
	autoexec += _T(":\\autoexec.bat");
	FILE *fp = ::_tfopen(autoexec.c_str(),_T("a+"));
	if(fp){
		::_ftprintf(fp,_T("\nset %s=%s\n"),name,value);
		::fclose(fp);
		return true;
	}else return false;
}

