#include "stdafx.h"
#include "setdlg.h"
#include "resource.h"
#include "setting.h"

extern TCHAR *g_url[];
extern setting g_setting;

bool SetDlg::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::Combo urllist(wnd,IDC_URLLIST);
	TCHAR **url = g_url;
	while(*url)urllist.AddString(*(url++));
	if(g_setting.IsURLList()){
		ablib::window::Edit(wnd,IDC_URL).SetReadOnly(true);
	}else{
		urllist.Enabled(false);
		ablib::window::CheckBox(wnd,IDC_ISURLLIST).SetCheck(true);
		ablib::window::Edit(wnd,IDC_URL).SetText(g_setting.GetURL());
	}
	urllist.SetCurSel(0);
	for(int i = 0 ; i < urllist.GetCount() ; ++i){
		if(urllist.GetText(i) == g_setting.GetURL()){
			urllist.SetCurSel(i);
			break;
		}
	}
	return true;
}



bool SetDlg::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_ISURLLIST:
	{
		ablib::window::CheckBox c(wnd,IDC_ISURLLIST);
		ablib::window::Edit(wnd,IDC_URL).SetReadOnly(!c.GetCheck());
		ablib::window::Combo(wnd,IDC_URLLIST).Enabled(!c.GetCheck());
		return true;
	}
	case IDOK:
		if(ablib::window::CheckBox(wnd,IDC_ISURLLIST).GetCheck()){
			g_setting.SetURL(ablib::window::Edit(wnd,IDC_URL).GetText());
			g_setting.SetIsURLList(false);
		}else{
			g_setting.SetURL(ablib::window::Combo(wnd,IDC_URLLIST).GetText());
			g_setting.SetIsURLList(true);
		}
		wnd->Destroy(TRUE);
		return true;
	case IDCANCEL:
		wnd->Destroy(TRUE);
		return true;
	default:
		return false;
	}
}



