#include "stdafx.h"
#include "../kakuto3.h"
#include "Setting.h"
#include "SetDlg.h"
#include "GetInfo.h"
#include "dll.h"
#include <system/FindFile.h>
#include <ablib/IsKanji.h>

setting g_setting;
HINSTANCE g_dllint;
GetInfo g_GetInfo;
bool g_restart;

bool CreateDirectoryR(const TCHAR *path){
	TCHAR *q = new TCHAR[::lstrlen(path) + 2],*p;
	::lstrcpy(q,path);
#ifdef UNICODE
	for(p = q ; *p ; ++p){
#else
	for(p = q ; *p ; p += ablib::IsKanji(*p) ? 2 : 1){
#endif
		if(*p == '\\'){
			*p = '\0';
			if(::GetFileAttributes(q) == -1 && ::CreateDirectory(q,NULL) == FALSE){
				delete[] q;
				return false;
			}
			*p = '\\';
		}
	}
	delete[] q;
	return true;
}

PluginInfo plugin_infos[2];
EXPORT PluginInfo *Info(){
	plugin_infos[0].info = _T("Xy`FbJ[ispell̊pɂڐAłłD");
	plugin_infos[0].softname = _T("ispell");
	plugin_infos[1].info = plugin_infos[1].softname = NULL;
	return plugin_infos;
}

EXPORT bool PluginInit(const TCHAR *ini,const TCHAR *log){
	g_setting.SetINIFile(ini,log);
	return true;
}

EXPORT void Set(HWND hwnd,const TCHAR *soft){
	DLL dll;dll.loaddll();
	if(dll.dllfunc<bool>(_T("USESNETWORK"))){
		SetDlg set(g_dllint);
		set.Create(hwnd);
	}else{
		::MessageBox(hwnd,_T("lbg[NgȂ̂Ȃݒ̕Kv͂܂D"),_T("ispell"),0);
	}
}

EXPORT bool Sets(const TCHAR *soft){return true;}

EXPORT bool GetInfo(HWND hwnd){
	g_setting.Log(_T("ispell̏擾Jn"));
	bool b = g_GetInfo.Get(hwnd);
	g_setting.Log(_T("ispell̏擾I"));
	return b;
}

EXPORT bool IsDefault(const TCHAR *soft){return g_GetInfo.IsDefaultInstall();}

EXPORT bool Reboots(){return g_restart;}

EXPORT DownloadData GetDownloadData(const TCHAR *soft){
	DLFile dl;
	DownloadData rv;
	DLL dll;dll.loaddll();
	::ZeroMemory(&rv,sizeof(DownloadData));
	if(dll.dllfunc<bool>(_T("USESNETWORK"))){
		if(g_GetInfo.IsSuccess()){
			dl.url = g_GetInfo.GetURL();
			dl.file = _T("ispell.tar.xz");
			dl.size = g_GetInfo.GetSize();
			rv.dls = &dl;
			rv.success = true;
			rv.downnum = 1;
		}
	}else{
		rv.dls = NULL;
		rv.success = true;
		rv.downnum = 0;
	}
	return rv;
}

inline void SetDIRYen(ablib::string &dir){
	dir.replace(_T("/"),_T("\\"));
	if(dir != _T("") && dir[dir.length() - 1] != '\\')dir += _T("\\");
}

EXPORT bool Install(HWND hwnd,const TCHAR *soft,DLResult dlr){
	g_setting.Log(_T("ispell̃CXg["));
	for(int i = 0 ; i < dlr.size ; ++i){
		if(g_setting.GetURL() == dlr.results[i].url && dlr.results[i].state != success)return false;
	}
	DLL dll;
	if(!dll.loaddll()){
		g_setting.Log(_T("{̂̃[hɎsD"));
		return false;
	}
	try{
		if(!dll.dllfunc<bool>(_T("ISTARAVAILABLE"))){
			g_setting.Log(_T("tar𓀂ł܂D"));
			return false;
		}
		// ŏIIɂ́CċNvg_setting.GetISPELLDICTDIR() != sysdirlɂȂ悤ɂD
		const TCHAR *s = dll.dllfunc<const TCHAR*>(_T("DIRINPUT"),hwnd,
			_T("ispell̃VXeCXg[ꏊIłD"),
			g_setting.GetISPELLDICTDIR().c_str());
		if(s == NULL)return false;
		ablib::string sysdir = s;
		if(setting::GetEnv(_T("ISPELL_DICTDIR")) != _T("")){
			ablib::string sysdir_env = setting::GetEnv(_T("ISPELL_DICTDIR"));
			SetDIRYen(sysdir);sysdir.tolower();SetDIRYen(sysdir_env);sysdir_env.tolower();
			if(sysdir != sysdir_env){
				switch(::MessageBox(hwnd,
					_T("w肳ꂽfBNg͊ϐŎw肳ꂽ̂ƈقȂ܂D\r\n")
					_T("ϐɎw肳ꂽ̂ɂ܂HȂ͂ĈłȂ΂C\r\n")
					_T("CXg[߂Ȃ΃LZĂD"),
					_T("ispell"),MB_YESNOCANCEL)){
				case IDYES:
					g_setting.SetISPELLDICTDIR(sysdir);
					break;
				case IDNO:
					g_setting.SetISPELLDICTDIR(sysdir_env);
					break;
				case IDCANCEL:
					return false;
				}
			}else{
				g_setting.SetISPELLDICTDIR(sysdir);
			}
		}else{
			g_setting.SetISPELLDICTDIR(sysdir);
			sysdir = _T("");
		}

		s = dll.dllfunc<const TCHAR*>(_T("DIRINPUT"),hwnd,
			_T("ispelľlCXg[ꏊiz[fBNgjIłD"),
			g_setting.GetHome().c_str());
		if(s == NULL)return false;
		ablib::string home = s;
		if(setting::GetEnv(_T("HOME")) != _T("")){
			ablib::string home_env = setting::GetEnv(_T("HOME"));
			SetDIRYen(home);home.tolower();SetDIRYen(home_env);home_env.tolower();
			const TCHAR *p = home.c_str();
			if(home != home_env){
				switch(::MessageBox(hwnd,
					_T("w肳ꂽfBNg͊ϐŎw肳ꂽ̂ƈقȂ܂D\r\n")
					_T("ϐɎw肳ꂽ̂ɂ܂HȂ͂ĈłȂ΂C\r\n")
					_T("CXg[߂Ȃ΃LZĂD"),
					_T("ispell"),MB_YESNOCANCEL)){
				case IDYES:
					g_setting.SetHome(home_env);
					home = _T("");//HOME͐ݒ肵ȂD
					break;
				case IDNO:
					g_setting.SetHome(home);
					home = g_setting.GetHome();
					break;
				case IDCANCEL:
					return false;
				}
			}else home = _T("");
		}else{
			g_setting.SetHome(home);
			home = g_setting.GetHome();
		}

		::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("ispell𓀁cc")));
		ablib::string kaitoutarget = g_setting.GetTmpDir() + _T("ispell\\");
		if(!dll.dllfunc<bool>(
			_T("TARDLG"),
			hwnd,
			(ablib::string(dll.dllfunc<const TCHAR*>(_T("GETHOZONDIR"))) + _T("ispell.tar.xz")).c_str(),
			kaitoutarget.c_str())){
			g_setting.Log(_T("tar𓀂ɎsD"));
			::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
			return false;
		}

		// binfBNg̒g(TeX)\binɈڂ
		::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("\r\nt@C̃Rs[cc")));
		ablib::string target = ablib::string(dll.dllfunc<const TCHAR*>(_T("GETINSTALLDIR"))) + _T("bin\\");
		ablib::string from = kaitoutarget + _T("ispell-w32\\bin\\");
		ablib::system::FindFile ff;
		if(!ff.Begin(from + _T("*.exe"))){
			g_setting.Log(_T("binfBNǧɎsD"));
			::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
			return false;
		}
		WIN32_FIND_DATA wfd;
		while(ff.Next(&wfd)){
			::CopyFile((from + wfd.cFileName).c_str(),(target + wfd.cFileName).c_str(),TRUE);
		}
		ff.Close();

		// dicfBNg̒gRs[
		target = g_setting.GetISPELLDICTDIR();
		from = kaitoutarget + _T("ispell-w32\\dic\\");
		if(!ff.Begin(from + _T("*.*"))){
			g_setting.Log(_T("dicfBNǧɎsD"));
			::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
			return false;
		}
		CreateDirectoryR(target.c_str());
		while(ff.Next(&wfd)){
			::CopyFile((from + wfd.cFileName).c_str(),(target + wfd.cFileName).c_str(),TRUE);
		}
		ff.Close();

		::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("\r\nispellp̐ݒcc")));
		if(sysdir != g_setting.GetISPELLDICTDIR()){
			sysdir = g_setting.GetISPELLDICTDIR();
			sysdir.replace(_T("\\"),_T("/"));
			if(!dll.dllfunc<bool>(_T("SETSYSTEMENV"),_T("ISPELL_DICTDIR"),sysdir.c_str())){
				g_setting.Log(_T("ϐISPELL_DICTDIR̐ݒɎs"));
				::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
				return false;
			}else{
				g_setting.Log(_T("ϐISPELL_DICTDIR") + sysdir + _T("ݒ肵܂D"));
				g_restart = true;
			}
		}
		if(home != _T("")){
			CreateDirectoryR((home + _T("\\")).c_str());
			if(!dll.dllfunc<bool>(_T("SETUSERENV"),_T("HOME"),home.c_str())){
				g_setting.Log(_T("ϐHOME̐ݒɎs"));
				::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
				return false;
			}else{
				g_setting.Log(_T("ϐHOME") + home + _T("ݒ肵܂D"));
				g_restart = true;
			}
		}
		::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("\r\n")));
		return true;
	}
	catch(load_function l){
		g_setting.Log(ablib::string(_T("֐")) + l.funcname() + _T("̃[hɎsD"));
		::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
		return false;
	}
}





#ifdef __cplusplus
extern "C" 
#endif
BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD ul_reason_for_call, LPVOID pParam){
	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH:
		g_dllint = hInstance;
		g_restart = false;
		return TRUE;
	case DLL_PROCESS_DETACH:
		if(g_setting.IsWriteINI())g_setting.Write();
		return TRUE;
	default:
		break;
	}
	return TRUE;
}
