#ifndef __GETINFO_H__
#define __GETINFO_H__

#include <vector>
#include "../kakuto3.h"

class GetInfo{
public:
	GetInfo(){}
	~GetInfo(){}
	bool Get(HWND parent);
	const TCHAR *GetURL()const{return m_url.c_str();}
	size_type GetSize() const{return m_size;}
	bool IsSuccess() const{return m_issuccess;}
	bool IsDefaultInstall() const{return m_defaultinstall;}

private:
	ablib::string m_url;
	size_type m_size;
	HWND m_parent;
	bool m_issuccess,m_defaultinstall;
	bool GetFromNetwork(HWND parent);
	bool GetFromLocal(HWND parent);

	void AddMsg(HWND hwnd,const ablib::string &msg){::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(msg.c_str()));}
	bool CheckCancel(){return ::SendMessage(m_parent,WM_ISCANCEL,0,0) != FALSE;}
};

#endif //__GETINFO_H__
