#include "stdafx.h"
#include "../kakuto3.h"
#include "setting.h"
#include "GetInfo.h"
#include "dll.h"

setting g_setting;
HINSTANCE g_dllint;
GetInfo g_GetInfo;


PluginInfo plugin_infos[2];
EXPORT PluginInfo *Info(){
	plugin_infos[0].info = _T("ɂ{p̃NXt@CłD");
	plugin_infos[0].softname = _T("jsclasses");
	plugin_infos[1].softname = plugin_infos[1].info = NULL;
	return plugin_infos;
}

EXPORT bool PluginInit(const TCHAR *ini,const TCHAR *log){
	g_setting.SetINIFile(ini,log);
	return true;
}

EXPORT bool GetInfo(HWND hwnd){return g_GetInfo.Get(hwnd);}

EXPORT bool IsDefault(const TCHAR *soft){return g_GetInfo.IsDefaultInstall();}

EXPORT bool Reboots(){return false;}

EXPORT void Set(HWND hwnd,const TCHAR *soft){return;}

EXPORT bool Sets(const TCHAR *soft){return false;}

EXPORT DownloadData GetDownloadData(){
	static DLFile dl;
	DownloadData rv;
	::ZeroMemory(&rv,sizeof(DownloadData));
	DLL dll;dll.loaddll();
	bool usenet = false;
	try{
		usenet = dll.dllfunc<bool>(_T("USESNETWORK"));
	}catch(load_function l){
		g_setting.Log(ablib::string(_T("֐")) + l.funcname() + _T("̃[hɎs"));
		usenet = false;
	}
	if(usenet){
		if(g_GetInfo.IsSuccess()){
			dl.url = g_GetInfo.GetURL();
			dl.file = _T("jsclasses.zip");
			dl.size = g_GetInfo.GetSize();
			rv.dls = &dl;
			rv.success = true;
			rv.downnum = 1;
		}
	}else{
		rv.dls = NULL;
		rv.success = true;
		rv.downnum = 0;
	}
	return rv;
}

EXPORT bool Install(HWND hwnd,const TCHAR *soft,DLResult dlr){
	for(int i = 0 ; i < dlr.size ; ++i){
		if(::lstrcmp(dlr.results[i].url,g_GetInfo.GetURL()) == 0 && dlr.results[i].state != success)return false;
	}
	DLL dll;dll.loaddll();
	ablib::string dir,from;
	try{
		dir = dll.dllfunc<const TCHAR*>(_T("GETINSTALLDIR")) + g_setting.GetTargetDir() + _T("tex\\platex\\jsclasses\\");
		from = ablib::string(dll.dllfunc<const TCHAR*>(_T("GETHOZONDIR"))) + _T("jsclasses.zip");
	}catch(load_function l){
		g_setting.Log(ablib::string(_T("֐")) + l.funcname() + _T("̃[hɎs"));
		return false;
	}

	::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("jsclasses̃CXg[cc")));

	try{
		if(dll.dllfunc<bool>(_T("ZIPDLG"),hwnd,from.c_str(),dir.c_str())){
			::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("\r\n")));
			g_setting.Log(_T("jsclasses̃CXg[ɐD"));
			return true;
		}else{
			::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
			g_setting.Log(_T("jsclasses̃CXg[ɎsD"));
			return false;
		}
	}catch(load_function l){
		g_setting.Log(ablib::string(_T("֐")) + l.funcname() + _T("̃[hɎsD"));
		::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
		return false;
	}
}


#ifdef __cplusplus
extern "C" 
#endif
BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD ul_reason_for_call, LPVOID pParam){
	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH:
		g_dllint = hInstance;
		return TRUE;
	case DLL_PROCESS_DETACH:
		if(g_setting.IsWriteINI())g_setting.Write();
		return TRUE;
	default:
		break;
	}
	return TRUE;
}

