#include "stdafx.h"
#include "../kakuto3.h"
#include "setting.h"
#include "GetInfo.h"
#include "dll.h"

setting g_setting;
HINSTANCE g_dllint;
GetInfo g_GetInfo;

EXPORT bool Init(const TCHAR *ini,const TCHAR *log){
	g_setting.SetINIFile(ini,log);
	return true;
}
PluginInfo plugin_infos[2];
EXPORT PluginInfo *Info(){
	plugin_infos[0].info = _T("}Ȃǂ`ɕ֗TeX}ND");
	plugin_infos[0].softname = _T("Xy-pic");
	plugin_infos[1].softname = plugin_infos[1].info = NULL;
	return plugin_infos;
}

EXPORT bool GetInfo(HWND hwnd){return g_GetInfo.Get(hwnd);}

EXPORT bool IsDefaultInstall(const TCHAR *soft){return g_GetInfo.IsDefaultInstall();}

EXPORT bool IsNeedReboot(){return false;}

EXPORT void Set(const TCHAR *soft){return ;}

EXPORT bool IsNeedSetting(const TCHAR *soft){return false;}

EXPORT DownloadData GetDownloadData(){
	static DLFile dl;
	DownloadData rv;
	::ZeroMemory(&rv,sizeof(DownloadData));
	if(g_setting.IsUseNetwork()){
		if(g_GetInfo.IsSuccess()){
			dl.url = g_GetInfo.GetURL();
			dl.file = _T("xy-pic.tar.gz");
			dl.size = g_GetInfo.GetSize();
			rv.dls = &dl;
			rv.success = true;
			rv.downnum = 1;
		}
	}else{
		rv.dls = NULL;
		rv.success = true;
		rv.downnum = 0;
	}
	return rv;
}

EXPORT bool Install(HWND hwnd,const TCHAR *install){
	ablib::string dir = g_setting.GetTeXDir() + g_setting.GetTargetDir();
	ablib::string from = g_setting.GetHozonDir() + _T("xy-pic.tar.gz");
	::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("Xy-pic̃CXg[cc")));

	DLL dll;
	if(!dll.loaddll()){
		g_setting.Log(_T("{̂̃[hɎsD"));
		return false;
	}
	try{
		if(!dll.dllfunc<bool>(_T("ISTARAVAILABLE"))){
			::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
			g_setting.Log(_T("tar.gzt@C̉𓀂sł͂܂łD"));
			return false;
		}
		if(dll.dllfunc<bool>(_T("TARDLG"),hwnd,from.c_str(),dir.c_str())){
			::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("\r\n")));
			g_setting.Log(_T("Xy-pic̃CXg[ɐD"));
			return true;
		}else{
			::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
			g_setting.Log(_T("Xy-pic̃CXg[ɎsD"));
			return false;
		}
	}catch(load_function l){
		g_setting.Log(ablib::string(_T("֐")) + l.funcname() + _T("̃[hɎsD"));
		::SendMessage(hwnd,WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(_T("s\r\n")));
		return false;
	}
}


#ifdef __cplusplus
extern "C" 
#endif
BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD ul_reason_for_call, LPVOID pParam){
	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH:
		g_dllint = hInstance;
		return TRUE;
	case DLL_PROCESS_DETACH:
		return TRUE;
	default:
		break;
	}
	return TRUE;
}
