#include "stdafx.h"
#include "ziptool.h"
#include <process.h>
#include <window/dialog.h>
#include <ablib/IsKanji.h>
#include <zlib/zip.h>
#include "resource.h"
#include "kakuto3.h"


bool ziptool::CheckCancel(){
	return GetWindow()->SendMsg(WM_ISCANCEL,0,0) != FALSE;
}


bool ziptool::DeCompresDlg(ablib::window::Wnd *parent,const TCHAR *fname,const TCHAR *dir){
	m_file = fname;
	m_dir = dir;
	m_todo = decompress;
	return BaseModalDlg::Create(parent,IDD_ZIPDLG) ? true : false;
}

bool ziptool::OnInitDialog(ablib::window::Dialog *wnd){
	wnd->SetTitle(ablib::string::sprintf(_TR("%s 𓀒cc"),m_file.c_str()));
	ablib::window::StaticText(wnd,IDC_DIR).SetText(m_dir);
	m_Thread = reinterpret_cast<HANDLE>(::_beginthread(sStart,0,this));
	if(m_Thread == NULL)wnd->Destroy(FALSE);
	return true;
}

INT_PTR ziptool::OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){
	switch(msg){
	case WM_MESSAGE:
		ablib::window::Edit(wnd,IDC_FILE).SetText(reinterpret_cast<TCHAR *>(lParam));
		return TRUE;
	default:
		return FALSE;
	}
}

bool ziptool::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDCANCEL:
		m_zip.Stop();
		return true;
	default:
		return false;
	}
}

void ziptool::sStart(void *d){
	bool rv = false;
	ziptool *me = static_cast<ziptool *>(d);
	if(me->m_todo == decompress)rv = me->StartDeCompress();
	me->GetWindow()->Destroy(rv ? TRUE : FALSE);
}

bool ziptool::StartDeCompress(){
	return m_zip.DeCompress(m_file.c_str(),m_dir.c_str());
}

bool ziptool::WriteMsg(const TCHAR *msg){
	GetWindow()->SendMsg(WM_MESSAGE,0,reinterpret_cast<LPARAM>(const_cast<TCHAR*>(msg)));
	return true;
}


