#ifndef __ZIP_H__
#define __ZIP_H__

#include <functional>
#include <zlib/zip.h>
#include <window/basemodaldlg.h>

/*
* zip̉𓀂SDGW͖ܘ_zlib
*/

class ziptool : public ablib::window::BaseModalDlg{
public:
	ziptool(HINSTANCE appint) : BaseModalDlg(appint){m_zip.SetOutputMessageFunction(std::bind(&ziptool::WriteMsg,this,std::placeholders::_1));}
//	ziptool(HINSTANCE appint) : BaseModalDlg(appint){m_zip.m_msgfunc = std::bind(&ziptool::WriteMsg,*this,_1);}
//	ziptool(HINSTANCE appint) : BaseModalDlg(appint){m_zip.SetOutputMessageFunction(std::bind1st(std::mem_fun(&ziptool::WriteMsg),this));}
//	ziptool(HINSTANCE appint) : BaseModalDlg(appint){std::function<bool (const TCHAR*)> f = std::bind(&ziptool::WriteMsg,this,_1);}
	~ziptool(){}
	static bool DeCompress(const TCHAR *fname,const TCHAR *dir){zlib::Zip z;return z.DeCompress(fname,dir);}
	static bool DeCompress(const ablib::string &fname,const ablib::string &dir){return DeCompress(fname.c_str(),dir.c_str());}
	static bool Compress(const TCHAR *dir);
	static bool Compress(const ablib::string &dir){return Compress(dir.c_str());}
	bool DeCompresDlg(ablib::window::Wnd *parent,const TCHAR *fname,const TCHAR *dir);
	bool DeCompresDlg(ablib::window::Wnd *parent,const ablib::string &fname,const ablib::string &dir){return DeCompresDlg(parent,fname.c_str(),dir.c_str());}

private:
	enum todo{
		decompress,
		compress
	};
	int m_todo;
	bool m_iscancel;
	HANDLE m_Thread;
	ablib::string m_file,m_dir;
	zlib::Zip m_zip;

	static bool CreateDirectoryReflex(const ablib::string &strPath);

	static void sStart(void *d);
	bool StartDeCompress();
	bool StartCompress();

	bool WriteMsg(const TCHAR *msg);
	bool CheckCancel();

	bool OnInitDialog(ablib::window::Dialog *wnd);
	bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
	INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam);
};
#endif //__ZIP_H__

