#ifndef __DOWNLOAD_H__
#define __DOWNLOAD_H__

#include <vector>
#include <window/basemodaldlg.h>
#include <window/dialog.h>
#include <window/Window.h>
#include <ablib/Lock.h>
#include "InstallFiles.h"
#include "Plugin.h"

/*
_CAOoă_E[hDꂾD
*/

class Download : public IBindStatusCallback,ablib::window::BaseModalDlg, ablib::Lock{
public:
	Download(HINSTANCE appint) : BaseModalDlg(appint){}
	~Download(){}
	int down(ablib::window::Wnd *parent);

private:
	ablib::window::Wnd *m_parent;
	Plugin *m_plugin;
	struct DownloadList{
		ablib::string url,name;
		size_type size;
	};
	std::vector<DownloadList> m_downlist;
	std::vector<DownloadList>::iterator m_ite;
	size_type m_alreadydownsize,m_totalsize;
	DWORD m_starttime,m_lasttime;
	int m_ikutumeka;

	bool OnInitDialog(ablib::window::Dialog*wnd);
	bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
	INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam);

	HANDLE m_hThread;
	HANDLE m_event;
	static void sDialog(void *d);
	void Dialog(); 
	int StartDownload();
	void DispRestTime(size_type downsize,bool force);

	void WriteMsg(ablib::string &msg);
	void WriteMsg(const TCHAR *msg);
	void WriteTitle(ablib::string &title);
	void WriteTitle(const TCHAR *title);
	bool CheckCancel(){LOCK l(this);return m_isabort;}
	bool m_isabort;

	void SetProgressPos(int n){
		ablib::window::ProgressBar p(GetWindow(),IDC_PROGRESS);
		p.SetPos(n);
	}
	void SetProgress(int n,int m){
		ablib::window::ProgressBar p(GetWindow(),IDC_PROGRESS);
		if(n != 0)p.SetRange(n);
		if(m != 0)p.SetStep(m);
	}
	
	// 悭킩ĂȂ
	ULONG m_cRef;
	STDMETHODIMP OnProgress(ULONG ulProgress,ULONG ulProgressMax,ULONG ulStatusCode,LPCWSTR szStatusText);
	STDMETHODIMP_(ULONG) AddRef()	{ return (++m_cRef); }
	STDMETHODIMP_(ULONG) Release()	{ return (m_cRef ? --m_cRef : 0L); }
	STDMETHODIMP GetBindInfo( DWORD*, BINDINFO* ) { return E_NOTIMPL; }
	STDMETHODIMP GetPriority( LONG* ) { return E_NOTIMPL; }
	STDMETHODIMP OnLowResource( DWORD ) { return E_NOTIMPL; }
	STDMETHODIMP OnDataAvailable( DWORD, DWORD, FORMATETC*, STGMEDIUM* ) { return E_NOTIMPL; }
	STDMETHODIMP OnObjectAvailable( REFIID, IUnknown* ) { return E_NOTIMPL; }
	STDMETHODIMP OnStartBinding( DWORD, IBinding* ) { return E_NOTIMPL; }
	STDMETHODIMP OnStopBinding( HRESULT, LPCWSTR ) { return E_NOTIMPL; }
	STDMETHODIMP QueryInterface( REFIID riid, void** ppv );



};

#endif //__DOWNLOAD_H__

