#include "stdafx.h"
#include <stdio.h>
#include <vector>
#include <ablib/IsKanji.h>
#include "func.h"

int lstrcmpn(const TCHAR *a,const TCHAR *b,int n){
	while (--n > 0 && *a != '\0' && *b != '\0' && *a == *b){++a;++b;}
	return (*a - *b);
}



//PerlsplitƓ

void split(std::vector<ablib::string> &rvalue,const TCHAR *value,const TCHAR *key){
	TCHAR *p,*q,*string = new TCHAR[::lstrlen(value) + 1],tmp;
	::lstrcpy(string,value);
	q = string;
	while(p = ::_tcsstr(q,key)){
		tmp = *p;*p = '\0';
		rvalue.push_back(q);
		*p = tmp;q = p + 1;
	}
	rvalue.push_back(q);
	delete[] string;
	return;
}

bool GetLocalFileTime(const TCHAR *file,FILETIME *ft){
	WIN32_FIND_DATA wfd;
	HANDLE hfind = ::FindFirstFile(file,&wfd);
	if(hfind == INVALID_HANDLE_VALUE)return false;
	::FindClose(hfind);
//	::CopyMemory(ft ,&wfd.ftLastWriteTime,sizeof(FILETIME));
	*ft = wfd.ftLastWriteTime;
	return true;
}
/*
bool ExistFile(TCHAR *filename){
	HANDLE hFind;
	WIN32_FIND_DATA w32fd;
	hFind = ::FindFirstFile(filename,&w32fd);
	if(hFind == INVALID_HANDLE_VALUE)return false;
	::FindClose(hFind);
	return true;
}
*/

bool ExistFile(const TCHAR *filename){
	if(::GetFileAttributes(filename) == 0xFFFFFFFF)return false;
	else return true;
}

bool CreateDirectoryReflex(const TCHAR *path){
	TCHAR *q = new TCHAR[::lstrlen(path) + 2],*p;
	::lstrcpy(q,path);
#ifdef UNICODE
	for(p = q ; *p ; ++p){
#else
	for(p = q ; *p ; p += ablib::IsKanji(*p) ? 2 : 1){
#endif
		if(*p == '\\'){
			*p = '\0';
			if(ExistFile(q) == false && ::CreateDirectory(q,NULL) == FALSE){
				delete[] q;
				return false;
			}
			*p = '\\';
		}
	}
	delete[] q;
	return true;
}

int CheckSameFile(const TCHAR *filename1,const TCHAR *filename2){
	TCHAR *f1,*f2;
	int rv;
	if(::lstrcmp(filename1,_T("")) == 0 || ::lstrcmp(filename2,_T("")) == 0)return FALSE;
	f1 = TransRegularPath(filename1);
	f2 = TransRegularPath(filename2);
	::CharLowerBuff(f1,::lstrlen(f1));
	::CharLowerBuff(f2,::lstrlen(f2));
	rv = ::lstrcmp(f1,f2);
	delete[] f1;delete[] f2;
	if(rv == 0)return TRUE;
	else return FALSE;
}

TCHAR *TransRegularPath(const TCHAR *fn){
	TCHAR *rv;
	std::vector<ablib::string> sa,sa2;
	UINT i;
	int len = 0;
	split(sa,const_cast<TCHAR *>(fn),_T("\\"));
	for(i = 0 ; i < sa.size() ; ++i){
		if(::lstrcmp(sa[i].c_str(),_T(".")) == 0)continue;
		else if(::lstrcmp(sa[i].c_str(),_T("..")) == 0)sa2.pop_back();
		else if(::lstrcmp(sa[i].c_str(),_T("")) == 0)continue;
		else sa2.push_back(sa[i]);
	}
	for(i = 0 ; i < sa2.size() ; ++i)len += sa2[i].length();
	rv = new TCHAR[len + sa2.size() + 2];
	::lstrcpy(rv,_T(""));
	for(i = 0 ; i < sa2.size() ; ++i){
		if(i != 0)::lstrcat(rv,_T("\\"));
		::lstrcat(rv,sa2[i].c_str());
	}
	return rv;
}

