#include "stdafx.h"
#include <window/dialog.h>
#include "getdir.h"
#include "resource.h"
#include "File.h"

bool GetDir::Create(ablib::window::Wnd *parent,const TCHAR *title,ablib::string &buf){
	m_buf = buf;
	m_title = title;
	m_rv = false;
	BaseModalDlg::Create(parent,IDD_GETDIR);
	buf = m_buf;
	return m_rv;
}

bool GetDir::OnInitDialog(ablib::window::Dialog *wnd){
	wnd->SetTitle(m_title);
	ablib::window::Edit ed(wnd,IDC_DIR);
	ed.SetText(m_buf);
	return true;
}

bool GetDir::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	ablib::string str;
	switch(id){
	case IDC_SANSYO:
		if(ablib::window::CommonDlg(wnd).SelectDir(str,_TR("fBNgIł"),_T(""))){
			ablib::window::Edit(wnd,IDC_DIR).SetText(str);
		}
		return true;
	case IDOK:
		m_buf = ablib::window::Edit(wnd,IDC_DIR).GetText();
		m_rv = true;
		wnd->Destroy(0);
		return true;
	case IDCANCEL:
		m_buf = _T("");
		m_rv = false;
		wnd->Destroy(0);
		return true;
	default:
		return false;
	}
}

