#ifndef __MAINDLG_H__
#define __MAINDLG_H__

#include "plugin.h"
#include <vector>
#include <window/propsheet.h>



/*
* C_CAODvɃCD
*/

class MainDlg : public ablib::window::BaseWizard{
public:
	MainDlg();
	~MainDlg(){}
	int Create();

	static const int CHANGE_LANGUAGE = 12345;// l͓K

private:
	Plugin *m_plugin;
	struct DlgProp0 : public SheetWnd{
		DlgProp0(WORD id) : SheetWnd(true,false,false,id){}
		void SetParent(MainDlg *p){m_parent = p;}
		bool OnInitDialog(ablib::window::Dialog *wnd);
		bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
		MainDlg *m_parent;
	}m_dlgprop0;

	struct DlgProp1 : public SheetWnd{
		DlgProp1(WORD id) : SheetWnd(true,true,false,id){}
		bool OnInitDialog(ablib::window::Dialog *wnd);
		LPCTSTR OnWizNext(ablib::window::Dialog *wnd);
		bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
	}m_dlgprop1;

	struct DlgProp2 : public SheetWnd{
		DlgProp2(WORD id) : SheetWnd(true,true,false,id){}
		void SetParent(MainDlg *p){m_parent = p;}
		LPCTSTR OnSetActive(ablib::window::Dialog *wnd);
		bool OnInitDialog(ablib::window::Dialog *wnd);
		bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
		LPCTSTR OnWizNext(ablib::window::Dialog *wnd);
		MainDlg *m_parent;
	}m_dlgprop2;

	struct DlgProp3 : public SheetWnd{
		DlgProp3(WORD id) : SheetWnd(true,true,false,id){}
		bool OnInitDialog(ablib::window::Dialog *wnd);
		bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
		LPCTSTR OnSetActive(ablib::window::Dialog *wnd);
		LPCTSTR OnWizNext(ablib::window::Dialog *wnd);
		MainDlg *m_parent;
		void SetParent(MainDlg *p){m_parent = p;}
	}m_dlgprop3;

	struct DlgProp4 : public SheetWnd{
		DlgProp4(WORD id) : SheetWnd(false,false,true,id){}
		void SetParent(MainDlg *p){m_parent = p;}
		bool OnWizFinish(ablib::window::Dialog *wnd);
		LPCTSTR OnSetActive(ablib::window::Dialog *wnd);
		MainDlg *m_parent;
		void SetLastMsg(ablib::window::Dialog *wnd);
	}m_dlgprop4;

	struct PluginProp : public SheetWnd{
		PluginProp(WORD id) : SheetWnd(true,true,false,id){}
		~PluginProp(){}
		void SetParent(MainDlg *p){m_parent = p;}
		bool OnInitDialog(ablib::window::Dialog *wnd);
		LPCTSTR OnSetActive(ablib::window::Dialog *wnd);
		INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
		MainDlg *m_parent;
	}m_pluginprop;

	struct OtherSoftProp : public SheetWnd{
		OtherSoftProp(WORD id) : SheetWnd(true,true,false,id){}
		~OtherSoftProp(){}
		void SetParent(MainDlg *p){m_parent = p;}
		bool OnInitDialog(ablib::window::Dialog *wnd);
		LPCTSTR OnWizNext(ablib::window::Dialog *wnd);
		LPCTSTR OnSetActive(ablib::window::Dialog *wnd);
		MainDlg *m_parent;
	}m_otherinfoprop;

	friend struct PluginProp;
	friend struct OtherSoftProp;
	friend struct DlgProp0;
	friend struct DlgProp1;
	friend struct DlgProp2;
	friend struct DlgProp3;
	friend struct DlgProp4;

	int m_rv;

};

#endif //__MAINDLG_H__

