#include "stdafx.h"
#include "ziptool.h"// ruby.hOȂƃG[ɂȂD
#include <ruby.h>
#include <boost/lexical_cast.hpp>
#include <ablib/SmallBuffer.h>
#include "Plugin.h"
#include "RubySys.h"
#include "RubyPlugin.h"
#include "kakuto3.h"
#include "ShortCut.h"
#include "Path.h"
#include "setting.h"
#include "InstallFiles.h"

extern Path g_path;
extern setting g_setting;
extern Plugin g_plugin;
extern InstallFiles g_InstallFiles;
ablib::string tmp_string;

VALUE g_ProtectBufferList;

Tar *Ruby::m_Tar = NULL;
bool Ruby::m_registerplugin_called = false;

Ruby::Ruby(){
	// RubyHOMEϐa݂Ȃ̂ŁCΏ
	int len = ::GetEnvironmentVariable(_T("HOME"),NULL,0);
	TCHAR *home = NULL;
	if(len != 0){
		home = new TCHAR[len + 1];
		::GetEnvironmentVariable(_T("HOME"),home,len + 1);
	}
	
	int argc;char **dummy_argv;
	::NtInitialize(&argc,&dummy_argv);
	argc = 2;
	char *argv[2];
	char rubyname[] = "ruby";
	argv[0] = rubyname;
	ablib:: basic_string<char> roption = ablib::TransCode::ToChar(g_setting.GetRubyOption());
	argv[1] = new char[roption.length() + 1];
	::lstrcpyA(argv[1],roption.c_str());
//	RUBY_INIT_STACK

/*
	MEMORY_BASIC_INFORMATION mi;
	DWORD size;
	DWORD space;

	if (VirtualQuery(&mi, &mi, sizeof(mi))) {
		size = (char *)mi.BaseAddress - (char *)mi.AllocationBase;
		space = size / 5;
		if (space > 1024*1024) space = 1024*1024;
	}
	g_setting.Log(_T("STACK_LEVEL_MAX + GC_WATER_MARK = ") + boost::lexical_cast<ablib::string>(512 + (size_t)(size - space) / sizeof(VALUE)));
	{VALUE *p;g_setting.Log(_T(__FILE__ "(") + boost::lexical_cast<ablib::string>(__LINE__) + _T("): ruby_stack_length = ") + boost::lexical_cast<ablib::string>(ruby_stack_length(&p)));}
*/

	::ruby_init();
//	::ruby_prog_init();
	::ruby_options(argc, argv);
//	::ruby_init_loadpath();
	delete[] argv[1];

	::SetEnvironmentVariable(_T("HOME"),home);
	delete[] home;

	g_ProtectBufferList = ::rb_ary_new();
	::rb_global_variable(&g_ProtectBufferList);

	m_abtexinstmodule = ::rb_define_module("AbTeXinst");
	AddProtectGCList(m_abtexinstmodule);

	::rb_define_module_function(m_abtexinstmodule,"get_specialfolder",reinterpret_cast<RUBY_FUNCTION>(GETSPECIALFOLDER),1);
	::rb_define_module_function(m_abtexinstmodule,"create_shortcut",reinterpret_cast<RUBY_FUNCTION>(CREATESHORTCUT),4);
	::rb_define_module_function(m_abtexinstmodule,"zip",reinterpret_cast<RUBY_FUNCTION>(ZIP),2);
	::rb_define_module_function(m_abtexinstmodule,"zipdlg",reinterpret_cast<RUBY_FUNCTION>(ZIPDLG),3);
	::rb_define_module_function(m_abtexinstmodule,"tar_available?",reinterpret_cast<RUBY_FUNCTION>(ISTARAVAILABLE),0);
	::rb_define_module_function(m_abtexinstmodule,"tardlg",reinterpret_cast<RUBY_FUNCTION>(TARDLG),3);
	::rb_define_module_function(m_abtexinstmodule,"dir_input",reinterpret_cast<RUBY_FUNCTION>(DIRINPUT),3);
	::rb_define_module_function(m_abtexinstmodule,"set_systemenv",reinterpret_cast<RUBY_FUNCTION>(SETSYSTEMENV),2);
	::rb_define_module_function(m_abtexinstmodule,"set_userenv",reinterpret_cast<RUBY_FUNCTION>(SETUSERENV),2);
	::rb_define_module_function(m_abtexinstmodule,"set_message",reinterpret_cast<RUBY_FUNCTION>(SETMESSAGE),2);
	::rb_define_module_function(m_abtexinstmodule,"add_message",reinterpret_cast<RUBY_FUNCTION>(ADDMESSAGE),2);
	::rb_define_module_function(m_abtexinstmodule,"cancel?",reinterpret_cast<RUBY_FUNCTION>(ISCANCEL),1);
	::rb_define_module_function(m_abtexinstmodule,"message_box",reinterpret_cast<RUBY_FUNCTION>(MESSAGEBOX),2);
	::rb_define_module_function(m_abtexinstmodule,"question_box",reinterpret_cast<RUBY_FUNCTION>(QUESTIONBOX),2);
	::rb_define_module_function(m_abtexinstmodule,"write_ini_str",reinterpret_cast<RUBY_FUNCTION>(WRITEINISTR),4);
	::rb_define_module_function(m_abtexinstmodule,"write_ini_int",reinterpret_cast<RUBY_FUNCTION>(WRITEINIINT),4);
	::rb_define_module_function(m_abtexinstmodule,"get_ini_str",reinterpret_cast<RUBY_FUNCTION>(GETINISTR),3);
	::rb_define_module_function(m_abtexinstmodule,"get_ini_int",reinterpret_cast<RUBY_FUNCTION>(GETINIINT),3);
	::rb_define_module_function(m_abtexinstmodule,"get_IEproxy_info",reinterpret_cast<RUBY_FUNCTION>(GETIEPROXYINFO),0);
	::rb_define_module_function(m_abtexinstmodule,"add_path",reinterpret_cast<RUBY_FUNCTION>(ADDPATH),1);
	::rb_define_module_function(m_abtexinstmodule,"del_path",reinterpret_cast<RUBY_FUNCTION>(DELETEPATH),1);
	::rb_define_module_function(m_abtexinstmodule,"update_lsr",reinterpret_cast<RUBY_FUNCTION>(UPDATELSR),0);
	::rb_define_module_function(m_abtexinstmodule,"get_windowpos",reinterpret_cast<RUBY_FUNCTION>(GETWINDOWPOS),1);
	::rb_define_module_function(m_abtexinstmodule,"register_plugin",reinterpret_cast<RUBY_FUNCTION>(REGISTERPLUGIN),2);
	::rb_define_module_function(m_abtexinstmodule,"enable_window",reinterpret_cast<RUBY_FUNCTION>(ENABLEWINDOW),2);
	::rb_define_module_function(m_abtexinstmodule,"sethwndtovrobj",reinterpret_cast<RUBY_FUNCTION>(SETHWNDTOVROBJ),2);
	::rb_define_module_function(m_abtexinstmodule,"getlanguage",reinterpret_cast<RUBY_FUNCTION>(GETLANGUAGE),0);

	::rb_define_const(m_abtexinstmodule,"NOT_DONE",INT2NUM(not_done));
	::rb_define_const(m_abtexinstmodule,"FAIL",INT2NUM(fail));
	::rb_define_const(m_abtexinstmodule,"SUCCESS",INT2NUM(success));
	::rb_define_const(m_abtexinstmodule,"CANCEL",INT2NUM(cancel));

	::rb_define_const(m_abtexinstmodule,"WM_MESSAGE",INT2NUM(WM_APP + 56));
	::rb_define_const(m_abtexinstmodule,"WM_ADDMESSAGE",INT2NUM(WM_APP + 57));
	::rb_define_const(m_abtexinstmodule,"WM_ISCANCEL",INT2NUM(WM_APP + 58));

	SetCSIDL();

	m_settingmodule = ::rb_define_module_under(m_abtexinstmodule,"Setting");
	AddProtectGCList(m_settingmodule);

	::rb_define_module_function(m_settingmodule,"hozon_dir",reinterpret_cast<RUBY_FUNCTION>(SETTING_HOZONDIR),0);
	::rb_define_module_function(m_settingmodule,"install_dir",reinterpret_cast<RUBY_FUNCTION>(SETTING_INSTALLDIR),0);
	::rb_define_module_function(m_settingmodule,"proxy",reinterpret_cast<RUBY_FUNCTION>(SETTING_PROXY),0);
	::rb_define_module_function(m_settingmodule,"use_network?",reinterpret_cast<RUBY_FUNCTION>(SETTING_USESNETWORK),0);
	::rb_define_module_function(m_settingmodule,"write_ini?",reinterpret_cast<RUBY_FUNCTION>(SETTING_WRITESINI),0);
	::rb_define_module_function(m_settingmodule,"set_hozon_dir",reinterpret_cast<RUBY_FUNCTION>(SETTING_SETHOZONDIR),1);
	::rb_define_module_function(m_settingmodule,"set_install_dir",reinterpret_cast<RUBY_FUNCTION>(SETTING_SETINSTALLDIR),1);
	::rb_define_module_function(m_settingmodule,"set_proxy",reinterpret_cast<RUBY_FUNCTION>(SETTING_SETPROXY),1);
}

void Ruby::SetCSIDL(){
	::rb_define_const(m_abtexinstmodule,"CSIDL_FLAG_CREATE",INT2NUM(CSIDL_FLAG_CREATE));
	::rb_define_const(m_abtexinstmodule,"CSIDL_ADMINTOOLS",INT2NUM(CSIDL_ADMINTOOLS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_ALTSTARTUP",INT2NUM(CSIDL_ALTSTARTUP));
	::rb_define_const(m_abtexinstmodule,"CSIDL_APPDATA",INT2NUM(CSIDL_APPDATA));
	::rb_define_const(m_abtexinstmodule,"CSIDL_BITBUCKET",INT2NUM(CSIDL_BITBUCKET));
	::rb_define_const(m_abtexinstmodule,"CSIDL_CDBURN_AREA",INT2NUM(CSIDL_CDBURN_AREA));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_ADMINTOOLS",INT2NUM(CSIDL_COMMON_ADMINTOOLS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_ALTSTARTUP",INT2NUM(CSIDL_COMMON_ALTSTARTUP));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_APPDATA",INT2NUM(CSIDL_COMMON_APPDATA));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_DESKTOPDIRECTORY",INT2NUM(CSIDL_COMMON_DESKTOPDIRECTORY));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_DOCUMENTS",INT2NUM(CSIDL_COMMON_DOCUMENTS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_FAVORITES",INT2NUM(CSIDL_COMMON_FAVORITES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_MUSIC",INT2NUM(CSIDL_COMMON_MUSIC));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_PICTURES",INT2NUM(CSIDL_COMMON_PICTURES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_PROGRAMS",INT2NUM(CSIDL_COMMON_PROGRAMS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_STARTMENU",INT2NUM(CSIDL_COMMON_STARTMENU));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_STARTUP",INT2NUM(CSIDL_COMMON_STARTUP));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_TEMPLATES",INT2NUM(CSIDL_COMMON_TEMPLATES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMMON_VIDEO",INT2NUM(CSIDL_COMMON_VIDEO));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COMPUTERSNEARME",INT2NUM(CSIDL_COMPUTERSNEARME));
	::rb_define_const(m_abtexinstmodule,"CSIDL_CONNECTIONS",INT2NUM(CSIDL_CONNECTIONS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_CONTROLS",INT2NUM(CSIDL_CONTROLS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_COOKIES",INT2NUM(CSIDL_COOKIES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_DESKTOP",INT2NUM(CSIDL_DESKTOP));
	::rb_define_const(m_abtexinstmodule,"CSIDL_DESKTOPDIRECTORY",INT2NUM(CSIDL_DESKTOPDIRECTORY));
	::rb_define_const(m_abtexinstmodule,"CSIDL_DRIVES",INT2NUM(CSIDL_DRIVES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_FAVORITES",INT2NUM(CSIDL_FAVORITES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_FLAG_DONT_VERIFY",INT2NUM(CSIDL_FLAG_DONT_VERIFY));
	::rb_define_const(m_abtexinstmodule,"CSIDL_FONTS",INT2NUM(CSIDL_FONTS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_HISTORY",INT2NUM(CSIDL_HISTORY));
	::rb_define_const(m_abtexinstmodule,"CSIDL_INTERNET",INT2NUM(CSIDL_INTERNET));
	::rb_define_const(m_abtexinstmodule,"CSIDL_INTERNET_CACHE",INT2NUM(CSIDL_INTERNET_CACHE));
	::rb_define_const(m_abtexinstmodule,"CSIDL_LOCAL_APPDATA",INT2NUM(CSIDL_LOCAL_APPDATA));
	::rb_define_const(m_abtexinstmodule,"CSIDL_MYDOCUMENTS",INT2NUM(CSIDL_MYDOCUMENTS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_MYMUSIC",INT2NUM(CSIDL_MYMUSIC));
	::rb_define_const(m_abtexinstmodule,"CSIDL_MYPICTURES",INT2NUM(CSIDL_MYPICTURES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_MYVIDEO",INT2NUM(CSIDL_MYVIDEO));
	::rb_define_const(m_abtexinstmodule,"CSIDL_NETHOOD",INT2NUM(CSIDL_NETHOOD));
	::rb_define_const(m_abtexinstmodule,"CSIDL_NETWORK",INT2NUM(CSIDL_NETWORK));
	::rb_define_const(m_abtexinstmodule,"CSIDL_PERSONAL",INT2NUM(CSIDL_PERSONAL));
//	::rb_define_const(m_abtexinstmodule,"CSIDL_PHOTOALBUMS",INT2NUM(CSIDL_PHOTOALBUMS));
//	::rb_define_const(m_abtexinstmodule,"CSIDL_PLAYLISTS",INT2NUM(CSIDL_PLAYLISTS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_PRINTERS",INT2NUM(CSIDL_PRINTERS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_PRINTHOOD",INT2NUM(CSIDL_PRINTHOOD));
	::rb_define_const(m_abtexinstmodule,"CSIDL_PROFILE",INT2NUM(CSIDL_PROFILE));
	::rb_define_const(m_abtexinstmodule,"CSIDL_PROGRAM_FILES",INT2NUM(CSIDL_PROGRAM_FILES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_PROGRAM_FILES_COMMON",INT2NUM(CSIDL_PROGRAM_FILES_COMMON));
	::rb_define_const(m_abtexinstmodule,"CSIDL_PROGRAMS",INT2NUM(CSIDL_PROGRAMS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_RECENT",INT2NUM(CSIDL_RECENT));
	::rb_define_const(m_abtexinstmodule,"CSIDL_RESOURCES",INT2NUM(CSIDL_RESOURCES));
//	::rb_define_const(m_abtexinstmodule,"CSIDL_SAMPLE_MUSIC",INT2NUM(CSIDL_SAMPLE_MUSIC));
//	::rb_define_const(m_abtexinstmodule,"CSIDL_SAMPLE_PLAYLISTS",INT2NUM(CSIDL_SAMPLE_PLAYLISTS));
//	::rb_define_const(m_abtexinstmodule,"CSIDL_SAMPLE_PICTURES",INT2NUM(CSIDL_SAMPLE_PICTURES));
//	::rb_define_const(m_abtexinstmodule,"CSIDL_SAMPLE_VIDEOS",INT2NUM(CSIDL_SAMPLE_VIDEOS));
	::rb_define_const(m_abtexinstmodule,"CSIDL_SENDTO",INT2NUM(CSIDL_SENDTO));
	::rb_define_const(m_abtexinstmodule,"CSIDL_STARTMENU",INT2NUM(CSIDL_STARTMENU));
	::rb_define_const(m_abtexinstmodule,"CSIDL_STARTUP",INT2NUM(CSIDL_STARTUP));
	::rb_define_const(m_abtexinstmodule,"CSIDL_SYSTEM",INT2NUM(CSIDL_SYSTEM));
	::rb_define_const(m_abtexinstmodule,"CSIDL_TEMPLATES",INT2NUM(CSIDL_TEMPLATES));
	::rb_define_const(m_abtexinstmodule,"CSIDL_WINDOWS",INT2NUM(CSIDL_WINDOWS));
}

VALUE Ruby::GETSPECIALFOLDER(VALUE self,VALUE dirtype){
	TCHAR buf[4096];
	LPITEMIDLIST id;
	LPMALLOC mal;
	if(FAILED(::SHGetMalloc(&mal)))return Qnil;
	if(FAILED(::SHGetSpecialFolderLocation(NULL,NUM2INT(dirtype),&id)))return Qnil;
	if(!::SHGetPathFromIDList(id,buf))return Qnil;
	mal->Free(id);
	if(buf[::lstrlen(buf) - 1] == '\\')buf[::lstrlen(buf) - 1] = '\0';
	tmp_string = buf;
	return ToRubyString(tmp_string.c_str());
}

void Ruby::AddProtectGCList(VALUE val){
	::rb_ary_push(g_ProtectBufferList,val);
}

VALUE Ruby::CREATESHORTCUT(VALUE self,VALUE from,VALUE arg,VALUE dir,VALUE to){
	Check_Type(from,T_STRING);
	Check_Type(arg,T_STRING);
	Check_Type(dir,T_STRING);
	Check_Type(to,T_STRING);
	return ShortCut::CreateShortCut(FromRubyString(from),FromRubyString(arg),FromRubyString(dir),FromRubyString(to)) ? Qtrue : Qfalse;
}

VALUE Ruby::SETMESSAGE(VALUE self,VALUE hwnd,VALUE str){
	Check_Type(str,T_STRING);
	::SendMessage((HWND)(NUM2INT(hwnd)),WM_MESSAGE,0,reinterpret_cast<LPARAM>(FromRubyString(str).c_str()));
	return Qtrue;
}

VALUE Ruby::ADDMESSAGE(VALUE self,VALUE hwnd,VALUE str){
	Check_Type(str,T_STRING);
	tmp_string = FromRubyString(str);
	::SendMessage((HWND)(NUM2INT(hwnd)),WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(tmp_string.c_str()));
	return Qtrue;
}

VALUE Ruby::ISCANCEL(VALUE self,VALUE hwnd){
	return ::SendMessage((HWND)(NUM2INT(hwnd)),WM_ISCANCEL,0,0) == TRUE ? Qtrue : Qfalse;
}

VALUE Ruby::WRITEINISTR(VALUE self, VALUE file, VALUE sec, VALUE key, VALUE str){
	Check_Type(file,T_STRING);
	Check_Type(sec,T_STRING);
	Check_Type(key,T_STRING);
	Check_Type(str,T_STRING);

	return ::WritePrivateProfileString(FromRubyString(sec).c_str(),FromRubyString(key).c_str(),FromRubyString(str).c_str(),FromRubyString(file).c_str()) != FALSE ? Qtrue : Qfalse;
}

VALUE Ruby::WRITEINIINT(VALUE self, VALUE file, VALUE sec, VALUE key, VALUE val){
	Check_Type(file,T_STRING);
	Check_Type(sec,T_STRING);
	Check_Type(key,T_STRING);

	ablib::string write = boost::lexical_cast<ablib::string>(NUM2INT(val));

	return ::WritePrivateProfileString(FromRubyString(sec).c_str(),FromRubyString(key).c_str(),write.c_str(),FromRubyString(file).c_str()) != FALSE ? Qtrue : Qfalse;
}

VALUE Ruby::GETINISTR(VALUE self, VALUE file, VALUE sec, VALUE key){
	Check_Type(file,T_STRING);
	Check_Type(sec,T_STRING);
	Check_Type(key,T_STRING);

	static TCHAR buf[4096];buf[0] = '\0';
	::GetPrivateProfileString(FromRubyString(sec).c_str(),FromRubyString(key).c_str(),_T(""),buf,4095,FromRubyString(file).c_str());
	return ToRubyString(buf);
}

VALUE Ruby::GETINIINT(VALUE self, VALUE file, VALUE sec, VALUE key){
	Check_Type(file,T_STRING);
	Check_Type(sec,T_STRING);
	Check_Type(key,T_STRING);

	return INT2NUM(::GetPrivateProfileInt(FromRubyString(sec).c_str(),FromRubyString(key).c_str(),0,FromRubyString(file).c_str()));
}

VALUE Ruby::GETIEPROXYINFO(VALUE self){
	HINTERNET open = ::InternetOpen(_T("AbTeXinst"),INTERNET_OPEN_TYPE_PRECONFIG,NULL,NULL,0);
	DWORD size = 4095;
	char buf[4096] = {0};
	INTERNET_PROXY_INFO *ipi = reinterpret_cast<INTERNET_PROXY_INFO*>(buf);
	if(!::InternetQueryOption(open,INTERNET_OPTION_PROXY,ipi,&size)){
		::InternetCloseHandle(open);
		return Qnil;
	}
	::InternetCloseHandle(open);
	VALUE rv = ::rb_hash_new();

	if(!ipi->lpszProxy)return Qnil;

	const TCHAR *r = ::_tcsstr(ipi->lpszProxy,_T(":"));
	if(!r)return Qnil;
	TCHAR proxy[4096];::lstrcpyn(proxy,ipi->lpszProxy,r - ipi->lpszProxy + 1);
	::rb_hash_aset(rv,::rb_str_new2("server"),ToRubyString(proxy));
	try{
		::rb_hash_aset(rv,::rb_str_new2("port"),INT2NUM(boost::lexical_cast<int>(r + 1)));
	}catch(...){
		::rb_hash_aset(rv,::rb_str_new2("port"),INT2NUM(0));
	}
	return rv;
}

VALUE Ruby::GETWINDOWPOS(VALUE self,VALUE hwnd){
	RECT rc;
	::GetWindowRect((HWND)NUM2INT(hwnd),&rc);
	VALUE rv = ::rb_ary_new();
	::rb_ary_push(rv,INT2NUM(rc.left));
	::rb_ary_push(rv,INT2NUM(rc.right));
	::rb_ary_push(rv,INT2NUM(rc.top));
	::rb_ary_push(rv,INT2NUM(rc.bottom));
	return rv;
}

VALUE Ruby::MESSAGEBOX(VALUE self,VALUE hwnd,VALUE msg){
	Check_Type(msg,T_STRING);
	int r = ::MessageBox((HWND)NUM2INT(hwnd),FromRubyString(msg).c_str(),_T("abtexinst"),MB_OK);
	return (r == IDOK ? Qtrue : Qnil);
}

VALUE Ruby::QUESTIONBOX(VALUE self,VALUE hwnd,VALUE msg){
	Check_Type(msg,T_STRING);
	int r = ::MessageBox((HWND)NUM2INT(hwnd),FromRubyString(msg).c_str(),_T("abtexinst"),MB_YESNOCANCEL);
	if(r == IDYES)return Qtrue;
	else if(r == IDNO)return Qfalse;
	else return Qnil;
}

#include "ziptool.h"

VALUE Ruby::ZIP(VALUE self,VALUE file,VALUE dir){
	Check_Type(file,T_STRING);
	Check_Type(dir,T_STRING);

	return ziptool::DeCompress(FromRubyString(file),FromRubyString(dir)) ? Qtrue : Qfalse;
}

VALUE Ruby::ZIPDLG(VALUE self,VALUE hwnd,VALUE file,VALUE dir){
	Check_Type(file,T_STRING);
	Check_Type(dir,T_STRING);
	ablib::window::Wnd w((HWND)(NUM2INT(hwnd)));
	ziptool z(ablib::system::Translation::GetResourceHandle());

	return z.DeCompresDlg(&w,FromRubyString(file),FromRubyString(dir)) ? Qtrue : Qfalse;
}

#include "Tar.h"
VALUE Ruby::ISTARAVAILABLE(VALUE self){
	if(!m_Tar)m_Tar = new Tar(ablib::system::Translation::GetResourceHandle());
	return m_Tar->IsAvailable() ? Qtrue : Qfalse;
}


VALUE Ruby::TARDLG(VALUE self,VALUE hwnd,VALUE file,VALUE dir){
	if(!m_Tar)m_Tar = new Tar(ablib::system::Translation::GetResourceHandle());

	Check_Type(file,T_STRING);
	Check_Type(dir,T_STRING);

	ablib::window::Wnd w((HWND)(NUM2INT(hwnd)));
	return m_Tar->Exec(&w,FromRubyString(file),FromRubyString(dir)) ? Qtrue : Qfalse;
}

#include "GetDir.h"

VALUE Ruby::DIRINPUT(VALUE self,VALUE hwnd,VALUE title,VALUE def){
	Check_Type(title,T_STRING);
	Check_Type(def,T_STRING);
	
	ablib::window::Wnd w((HWND)(NUM2INT(hwnd)));
	ablib::string rv = FromRubyString(def);
	GetDir g(ablib::system::Translation::GetResourceHandle());

	if(!g.Create(&w,FromRubyString(title),rv)){//O𔭐D
		return Qnil;
	}
	return ToRubyString(rv);
}

#include "SetEnv.h"
VALUE Ruby::SETSYSTEMENV(VALUE self,VALUE name,VALUE value){
	Check_Type(name,T_STRING);
	Check_Type(value,T_STRING);
	return SetEnv::SetSystem(FromRubyString(name),FromRubyString(value));
}

VALUE Ruby::SETUSERENV(VALUE self,VALUE name,VALUE value){
	Check_Type(name,T_STRING);
	Check_Type(value,T_STRING);
	return SetEnv::SetUser(FromRubyString(name),FromRubyString(value));
}


VALUE Ruby::ADDPATH(VALUE self, VALUE path){
	Check_Type(path,T_STRING);
	g_path.AddPath(FromRubyString(path));
	return Qtrue;
}

VALUE Ruby::DELETEPATH(VALUE self,VALUE path){
	Check_Type(path,T_STRING);
	g_path.DeletePath(FromRubyString(path));
	return Qtrue;
}

VALUE Ruby::UPDATELSR(VALUE self){
	g_InstallFiles.Updatelsr();
	return Qtrue;
}

VALUE Ruby::REGISTERPLUGIN(VALUE self,VALUE name,VALUE cls){
	m_registerplugin_called = true;
	if(TYPE(name) != T_STRING)return Qnil;
	int state = 0;
	VALUE mod = ::rb_protect(sClassNew,cls,&state);
	if(state != 0){
		VALUE rv = ::rb_protect(sGetLastError,Qnil,&state);
		if(state == 0 && TYPE(rv) == T_STRING){
			g_setting.Log(ablib::TransCode::FromChar(ruby_sourcefile) + _T("(") + boost::lexical_cast<ablib::string>(ruby_sourceline) + _T(") ") + FromRubyString(rv));
		}
		return Qnil;
	}
	RubyPlugin *ruby = new RubyPlugin();
	if(ruby->Load(FromRubyString(name),ablib::TransCode::FromChar(ruby_sourcefile),mod)){
		g_plugin.AddPlugin(ruby);
		return mod;
	}else return Qnil;
}

VALUE Ruby::ENABLEWINDOW(VALUE self,VALUE hwnd,VALUE b){
	HWND hw = (HWND)NUM2INT(hwnd);
	return ::EnableWindow(hw,b == Qtrue ? TRUE : FALSE) ? Qtrue : Qfalse;
}

VALUE Ruby::SETHWNDTOVROBJ(VALUE self,VALUE obj,VALUE hwnd){
	// VisualuRuby\[X̃RsyD
	struct SwinGDIStruct{
		HDC hdc;
		HPEN hpenOrg; 
		HBRUSH hbrushOrg;
		HFONT hfontOrg;
		int selectedObjFlag;  /* for Pen,Brush,... */
	};

	struct Swin{
		VALUE me;   /* thisself */
		unsigned long hInst;
		HWND hParent;
		HWND hWnd;
		HANDLE hEtc;
		TCHAR* classname;  
		DWORD dwStyle;
		DWORD dwExStyle;
		TCHAR* caption;
		int x,y,h,w;
		BOOL enabled;
		int painting;
		PAINTSTRUCT ps;
		struct SwinGDIStruct gs;
		LRESULT (CALLBACK* OrigWndProc) (HWND, UINT, WPARAM, LPARAM);
		struct SwinFilter* filter;
		DWORD nthread_id;
	};
	Swin *vrobj;
	Data_Get_Struct(obj,Swin,vrobj);
	vrobj->hWnd = (HWND)NUM2INT(hwnd);
	return obj;
}


VALUE Ruby::sGetLastError(VALUE module){
//	return rb_funcall(rb_errinfo(),rb_intern(_T("to_s")),0);
	return rb_funcall(ruby_errinfo,rb_intern("to_s"),0);
}

VALUE Ruby::sClassNew(VALUE cls){
	return ::rb_class_new_instance(0,NULL,cls);
}

// ȉ擾
VALUE Ruby::SETTING_HOZONDIR(VALUE self){
	return ToRubyString(g_setting.GetHozonDir());
}

VALUE Ruby::SETTING_INSTALLDIR(VALUE self){
	return ToRubyString(g_setting.GetInstallDir());
}

VALUE Ruby::SETTING_PROXY(VALUE self){
	if(::lstrcmp(g_setting.GetProxy(),_T("")) == 0)return Qnil;
	VALUE rv = ::rb_hash_new();
	::rb_hash_aset(rv,::rb_str_new2("server"),ToRubyString(g_setting.GetProxy()));
	::rb_hash_aset(rv,::rb_str_new2("port"),INT2NUM(g_setting.GetPortNum()));
	return rv;
}

VALUE Ruby::SETTING_USESNETWORK(VALUE self){
	return g_setting.IsUseNetwork()?Qtrue:Qfalse;
}

VALUE Ruby::SETTING_SETHOZONDIR(VALUE self,VALUE dir){
	Check_Type(dir,T_STRING);
	g_setting.SetHozonDir(FromRubyString(dir));
	return self;
}

VALUE Ruby::SETTING_SETINSTALLDIR(VALUE self, VALUE dir){
	Check_Type(dir,T_STRING);
	g_setting.SetInstallDir(FromRubyString(dir));
	return self;
}

VALUE Ruby::SETTING_SETPROXY(VALUE self, VALUE proxy){
	Check_Type(proxy,T_HASH);
	VALUE s = ::rb_hash_aref(proxy,::rb_str_new2("server"));
	VALUE p = ::rb_hash_aref(proxy,::rb_str_new2("port"));
	Check_Type(s,T_STRING);
	g_setting.SetProxy(FromRubyString(s));
	g_setting.SetPortNum(NUM2INT(p));
	return self;
}

VALUE Ruby::SETTING_WRITESINI(VALUE self){
	return g_setting.IsWriteINI() ? Qtrue : Qfalse;
}

VALUE Ruby::GETLANGUAGE(VALUE self){
	return INT2NUM(ablib::system::Translation::GetLanguage());
}

ablib::string Ruby::FromRubyString(VALUE val){
	return ablib::TransCode::FromChar(::StringValuePtr(val));
/*
	static ablib::SmallBuffer<wchar_t> wbuf;
	DWORD size = ::MultiByteToWideChar(CP_UTF8,0,StringValuePtr(val),-1,NULL,0);
	wbuf.Alloc(size + 1);
	size = ::MultiByteToWideChar(CP_UTF8,0,StringValuePtr(val),-1,wbuf.buf,wbuf.size);
	wbuf.buf[size] = L'\0';
#ifdef UNICODE
	return ablib::basic_string<wchar_t>(wbuf.buf);
#else
	static ablib::SmallBuffer<char> cbuf;
	DWORD csize = ::WideCharToMultiByte(CP_ACP,0,wbuf.buf,size,NULL,0,NULL,NULL);
	cbuf.Alloc(size + 1);
	size = ::WideCharToMultiByte(CP_ACP,0,wbuf.buf,size,cbuf.buf,cbuf.size,NULL,NULL);
	cbuf.buf[size] = '\0';
	return ablib::basic_string<char>(cbuf.buf);
#endif
*/
}

VALUE Ruby::ToRubyString(const ablib::string &str){
	return ::rb_str_new2(ablib::TransCode::ToChar(str).c_str());;
/*
	static ablib::SmallBuffer<char> rv;
#ifdef UNICODE
	DWORD size = ::WideCharToMultiByte(CP_UTF8,0,str.c_str(),str.length(),NULL,0,NULL,0);
	rv.Alloc(size);
	size = ::WideCharToMultiByte(CP_UTF8,0,str.c_str(),str.length(),rv.buf,rv.size,NULL,0);
#else
	static ablib::SmallBuffer<wchar_t> wbuf;
	DWORD size = ::MultiByteToWideChar(CP_ACP,0,str.c_str(),str.length(),NULL,0);
	wbuf.Alloc(size + 1);
	size = ::MultiByteToWideChar(CP_ACP,0,str.c_str(),str.length(),wbuf.buf,wbuf.size);
	wbuf.buf[size] = L'\0';
	size = ::WideCharToMultiByte(CP_UTF8,0,wbuf.buf,-1,NULL,0,NULL,0);
	rv.Alloc(size);
	size = ::WideCharToMultiByte(CP_UTF8,0,wbuf.buf,-1,rv.buf,rv.size,NULL,0);
#endif
	rv.buf[size] = '\0';
	return ::rb_str_new2(rv.buf);
*/
}

