# coding: Shift_JIS

require 'net/http'
require 'uri'
require 'time'

Net::HTTP.version_1_2

class SumatraPDF
	def initialize
		@ini = ""
		@log = ""
		
		@url = "http://www.sumatrapdfreader.org"
		@fileurl = ""
		@file = ""
		@size = 0
		@definstall = false
	end
	
	def info
		return [{"softname" => "SumatraPDF", "info" => "TeX ҏWɕ֗ PDF vr[A"}]
	end
	
	def plugin_init(ini,log)
		@ini = ini
		@log = log
	end
	
	def reboot?()
		return false
	end
	
	def set?(soft)
		return false
	end
	
	def set(hwnd,soft)
		return
	end
	
	def get_info(hwnd)
		srand();
		Log("SumatraPDF̏擾Jn")
		if AbTeXinst::Setting::use_network? == false then
			@file = findSumatraInstallFile();
			@definstall = File.exist?(AbTeXinst::Setting::hozon_dir + @file);
			return true;
		end
		uri = URI.parse(@url + "/sumatra.js")
		if uri.scheme != "http" then
			Log("httpłȂƂ܂D")
			return false
		end
		AbTeXinst::add_message(hwnd,"SumatraPDF̏擾Jn")
		
		response = nil
		proxy = AbTeXinst::Setting::proxy;
		if proxy == nil then
			proxy = AbTeXinst::get_IEproxy_info;
		end
		if proxy == nil or proxy["server"] == "" then
			proxy = {"server" => nil,"port" => nil};
		end
		Net::HTTP::Proxy(proxy["server"],proxy["port"]).start(uri.host){|http|
			response = http.get(uri.path)
		}
		
		if response == nil then
			AbTeXinst::add_message(hwnd,"擾Ɏs\r\n");
			Log("擾Ɏs");
			return false;
		end
		
		err = false;
		if !(/var gSumVer = "([0-9\.]+)"/ =~ response.body) then
			err = true;
		end
		@file = "SumatraPDF-" + $1 + "-install.exe";
		if err == false then
			if !(/var gSumZipUrl = "([^"]*)SumatraPDF-"/ =~ response.body) then
				err = true;
			end
			@fileurl = $1 + @file;
		end
		if err == true
			AbTeXinst::add_message(hwnd,"擾Ɏs\r\n");
			Log("CXg[URL擾Ɏs܂DWebTCg̍\啝ɕς\܂D");
		end
		uri = URI.parse(@fileurl);
		reponse = nil;
		
		Net::HTTP::Proxy(proxy["server"],proxy["port"]).start(uri.host){|http|
			response = http.head(uri.path);
		}

		if response == nil then
			AbTeXinst::add_message(hwnd,"擾ɎsD\r\n")
			Log("擾ɎsD")
			return false
		end

		@size = response['Content-Length'].to_i
		a = response['last-modified'];
		if @size == nil then
			Log("Content-Length = nil");
		end
		nettime = Time.parse(response['last-modified']) + 120
		begin
			localtime = File.mtime(AbTeXinst::Setting::hozon_dir + @file);
			@definstall = (localtime < nettime)
		rescue
			@definstall = true
		end
		
		Log("SumatraPDF̏擾I")
		AbTeXinst::add_message(hwnd,"\r\n")
		@success = true
		return true
		
	end
	
	def download_data(soft)
		if AbTeXinst::Setting::use_network? == false then
			return {
				"success" => true,
				"download_files" => []};
		else
			return {
				"success" => @success,
				"download_files" => [{
					"url" => @fileurl,
					"file" => @file,
					"size" => @size}]};
		end
	end
	
	
	def default?(soft)
		return @definstall;
	end
	
	
	def install(hwnd,soft,dlr)
		AbTeXinst::add_message(hwnd,"\r\nSumatraPDF̃CXg[cc");
		if AbTeXinst::Setting::use_network? == true then
			if dlr[@fileurl] == nil or dlr[@fileurl] != AbTeXinst::SUCCESS then
				AbTeXinst::add_message(hwnd,"s\r\n");
				return false;
			end
		end
		
		system('"' + AbTeXinst::Setting::hozon_dir + @file + '"');
		return true;
	end
	
	def plugin_uninit
	end
	
private
	def findSumatraInstallFile()
		dir = Dir.glob(AbTeXinst::Setting::hozon_dir + "SumatraPDF-*-install.exe");
		max = -1;
		@file = "";
		dir.each{|f|
			if /SumatraPDF-([0-9]+)\.([0-9]+)-install\.exe/ =~ f then
				v = $1.to_i * 1000 + $2;
				if v > max then
					@file = f;
					max = v;
				end
			end
		}
		return @file;
	end

	def Log(l)
		begin
			fp = File.open(@log,"a+")
		rescue
			return
		end
		fp.write(l + "\n");
		fp.close()
	end
	
end

AbTeXinst::register_plugin('SumatraPDF',SumatraPDF);
