# coding: Shift_JIS

require 'net/http'
require 'uri'
require 'time'

Net::HTTP.version_1_2

class Jsclasses
	def initialize
		@ini = ""
		@log = ""
		
		@url = "http://oku.edu.mie-u.ac.jp/~okumura/jsclasses/jsclasses.zip"
		@size = 0
		@success = false
		@definstall = true
		return true
	end
	
	def info
		return [{"softname" => "jsclasses", "info" => "ɂ{p̃NXt@CłD"}]
	end
	
	
	def plugin_init(ini,log)
		@ini = ini
		@log = log
	end
	
	
	def reboot?()
		return false
	end
	
	
	def set?(soft)
		return false
	end
	
	
	def set(hwnd,soft)
		return
	end
	
	
	def get_info(hwnd)
		Log("jsclasses̏擾Jn");
		if AbTeXinst::Setting::use_network? == false then
			begin
				@definstall = File.exist?(AbTeXinst::Setting::hozon_dir + "jsclasses.zip");
			rescue
				@definstall = false;
			end
			return true;
		end
		uri = URI.parse(@url);
		if uri.scheme != "http" then
			Log("httpłȂƃ_łD");
			return false;
		end
		AbTeXinst::add_message(hwnd,"\r\n\r\njsclasses̏擾Jn\r\n");

		response = nil;
		AbTeXinst::add_message(hwnd,uri.host + "ɐڑ擾܂D\r\n");
		
		proxy = AbTeXinst::Setting::proxy;
		if proxy == nil then
			proxy = AbTeXinst::get_IEproxy_info;
		end
		if proxy == nil or proxy["server"] == "" then
			proxy = {"server" => nil,"port" => nil};
		end
		Net::HTTP::Proxy(proxy["server"],proxy["port"]).start(uri.host){|http|
			response = http.head(uri.path);
		}
		if response == nil then
			AbTeXinst::add_message(hwnd,"擾ɎsD\r\n")
			Log("擾ɎsD")
			return false
		end
		
		@size = response['Content-Length'].to_i
		nettime = Time.parse(response['last-modified']) + 120
		begin
			localtime = File.mtime(AbTeXinst::Setting::hozon_dir + "jsclasses.zip");
			@definstall = (localtime < nettime)
		rescue
			@definstall = true
		end
		
		Log("jsclasses̏擾I")
		AbTeXinst::add_message(hwnd,"\r\n")
		@success = true
		return true
	end
	
	
	def download_data(soft)
		if AbTeXinst::Setting::use_network? == false then
			return {
				"success" => true,
				"download_files" => []};
		else
			return {
				"success" => @success,
				"download_files" => [{
					"url" => @url,
					"file" => "jsclasses.zip",
					"size" => @size
				}]
			};
		end
	end
	
	
	def default?(soft)
		return @definstall
	end
	
	
	def install(hwnd,soft,dlresult)
		AbTeXinst::add_message(hwnd,"jsclasses̃CXg[cc")
		Log("jsclasses̃CXg[");
		if AbTeXinst::Setting::use_network? == true then
			if dlresult[@url] == nil or dlresult[@url] != AbTeXinst::SUCCESS then
				AbTeXinst::add_message(hwnd,"s\r\n");
				return false
			end
		end
		# 2007/08/03 W32TeXptexfBNgȂ
#		dir = AbTeXinst::GETINISTR(@ini,"Dir","Install") + "share\\texmf-local\\ptex\\platex\\jsclasses\\"
		dir = AbTeXinst::Setting::install_dir + "share\\texmf-local\\tex\\platex\\jsclasses\\"
		from = AbTeXinst::Setting::hozon_dir + "jsclasses.zip"
		if AbTeXinst::zipdlg(hwnd,from,dir) then
			AbTeXinst::add_message(hwnd,"\r\n")
			Log("jsclasses̃CXg[ɐ")
			return true
		else
			AbTeXinst::add_message(hwnd,"s\r\n")
			Log("jsclasses̃CXg[Ɏs")
			return false
		end
	end
	
	def plugin_uninit
		return
	end
	
private
	def Log(l)
		begin
			fp = File.open(@log,"a+")
		rescue
			return
		end
		fp.write(l + "\n");
		fp.close()
	end
	
end

AbTeXinst::register_plugin('Jsclasses',Jsclasses);
