#ifndef __TAR_H__
#define __TAR_H__

#include <window/BaseModalDlg.h>
#include <system/Process.h>

class Tar : public ablib::window::BaseModalDlg
{
public:
	Tar(HINSTANCE appint) : m_dll(NULL),BaseModalDlg(appint){}
	~Tar();
	bool Exec(ablib::window::Wnd *wnd,const TCHAR *file,const TCHAR *dir);
	bool Exec(ablib::window::Wnd *wnd,const ablib::string &file,const ablib::string &dir){return Exec(wnd,file.c_str(),dir.c_str());}
	bool IsAvailable();

private:
	HMODULE m_dll;
	ablib::system::Process m_process;
	HANDLE m_thread;
	ablib::string m_file;

	static void sRead(void *d);

	bool OnInitDialog(ablib::window::Dialog *wnd);
	void Read();
};

#endif //__TAR_H__

