//cl kakuto3_patch.cpp user32.lib advapi32.lib

#include <windows.h>
#include <tchar.h>

bool IsNT(){
	OSVERSIONINFO os;

	os.dwOSVersionInfoSize=sizeof(os);
	::GetVersionEx(&os);

	return (os.dwPlatformId==VER_PLATFORM_WIN32_NT) ? true:false;
}


struct Mutex{
public:
	Mutex(const TCHAR *s) : m_mutex(NULL){::lstrcpy(m_str,s);}
	~Mutex(){if(m_mutex)::ReleaseMutex(m_mutex);}
	bool Create(){
		m_mutex = ::CreateMutex(FALSE,0,m_str);
		if(::GetLastError() == ERROR_ALREADY_EXISTS){
			m_mutex = NULL;
			return false;
		}else if(m_mutex == NULL){
			MessageBox(NULL,_T("ɎsD"),_T("kakuto3"),0);
			return false;
		}
		return true;
	}
	bool IsExist(){return m_mutex != NULL;}

private:
	HANDLE m_mutex;
	TCHAR m_str[512];
};

/**
* TeXCXg[PATH܂ƂɂȂĂ̂̏CvOD
* PATHREG_EXPAND_SZŏނłD
*/

TCHAR RegPath[] = _T("SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment");

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
	if(!IsNT()){
		if(::MessageBox(NULL,
		_T("NTnłȂƔf܂D\r\n")
		_T("sNTn̂̂Ȃ̂ŁC֌WȂ\Ǝv܂D\r\n")
		_T("NTnłȂWindowsőƕsN\܂D\r\n")
		_T("ł܂H"),
		_T("kakuto3"),MB_YESNO) == IDNO)return 0;
	}
	Mutex m(_T("kakuto3_patch"));
	if(!m.Create()){
		if(m.IsExist()){
			::MessageBox(NULL,_T("dN͋֎~łD"),NULL,0);
			return 0;
		}else{
			::MessageBox(NULL,_T("s̃G[܂D"),NULL,0);
			return 7;
		}
	}
	HKEY handle;
	if(::RegOpenKeyEx(HKEY_LOCAL_MACHINE,RegPath,0,KEY_ALL_ACCESS,&handle) != ERROR_SUCCESS){
		::MessageBox(NULL,_T("WXgJ܂łD"),NULL,0);
		return 1;
	}
	DWORD size,type;
	if(::RegQueryValueEx(handle,_T("PATH"),NULL,&type,NULL,&size) != ERROR_SUCCESS){
		::MessageBox(NULL,_T("WXgǂݍ߂܂łD"),NULL,0);
		::RegCloseKey(handle);
		return 2;
	}
	if(type == REG_EXPAND_SZ){
		::MessageBox(NULL,_T("ǂ珈ȂĂ݂łD"),_T("kakuto3"),0);
		::RegCloseKey(handle);
		return 2;
	}else if(type != REG_SZ){
		::MessageBox(NULL,
		_T("ǁ[PATHݒ肪ĂC܂D\r\n")
		_T("߂̃Rs[^ɏڂɂ݂Ă炢܂傤DWXg\r\n")
		_T("HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\r\n")
		_T("REG_SZɂREG_EXPAND_SZɂȂĂȂCƂ΂킩܂DƁD\r\n\r\n")
		_T("܂̓vÕoOłDꉞIs(abenori@ms.u-tokyo.ac.jp)ɘAĂ݂̂܂D")
		,NULL,0);
		::RegCloseKey(handle);
		return 5;
	}
	++size;
	TCHAR *s = new TCHAR[size];
	if(::RegQueryValueEx(handle,_T("PATH"),NULL,NULL,reinterpret_cast<BYTE*>(s),&size) != ERROR_SUCCESS){
		::MessageBox(NULL,_T("WXgǂݍ߂܂łD"),NULL,0);
		::RegCloseKey(handle);
		delete[] s;
		return 3;
	}
	if(::RegSetValueEx(handle,_T("PATH"),0,REG_EXPAND_SZ,reinterpret_cast<BYTE*>(s),size) != ERROR_SUCCESS){
		::MessageBox(NULL,_T("WXgɏ߂܂łD"),NULL,0);
		::RegCloseKey(handle);
		delete[] s;
		return 4;
	}
	::RegCloseKey(handle);
	::MessageBox(NULL,_T("܂Df܂D"),_T("kakuto3"),0);
	delete[] s;
	return 0;
}

