#include "stdafx.h"
#include <algorithm>
#include "setting.h"
#include "GetInfo.h"
#include <boost/lexical_cast.hpp>
#include <system/Time.h>
#include <system/File.h>
#include "dll.h"
#include <ablib/IsKanji.h>

extern setting g_setting;



bool GetInfo::HTTP::GetFileList(std::vector<GetInfo::FileData> &rv){
	rv.clear();
	DLL dll;
	if(!dll.loaddll()){
		g_setting.Log(_T("{̂̃[hɎsD"));
		return false;
	}

	if(!m_http.SendGET(m_curdir.c_str())){
		g_setting.Log(_T("GETNGXgMɎsD"));
		return false;
	}
	if(m_http.status_code() / 100 == 4 || m_http.status_code() / 100 == 5){
		g_setting.Log(_T("T[oG[R[h") + boost::lexical_cast<ablib::string>(m_http.status_code()) + _T("Ԃ܂D"));
		return false;
	}
	std::vector<BYTE> d;
	if(!m_http.data(d)){
		g_setting.Log(_T("f[^̎MɎsD"));
		return false;
	}
	ablib::string data = reinterpret_cast<const TCHAR*>(&d[0]);
	GetFileListFromIndexHtml(rv,data);
	return true;
}

bool GetInfo::FTP::GetFileList(std::vector<GetInfo::FileData> &rv){
	std::vector<FtpAccess::FileInfo> fis;
	if(!m_ftp.ls(_T("*.*"),fis))return false;
	FileData fd;
	
	for(FtpAccess::FileInfo &i : fis){
		fd.file = i.name;fd.size = i.size;fd.time = i.time;
		rv.push_back(fd);
	}
	return true;
}

bool GetInfo::Get(HWND parent){
	m_parent = parent;
	AddMsg(_T("ispell̏擾\r\n"));
	DLL dll;dll.loaddll();
	if(dll.dllfunc<bool>(_T("USESNETWORK"))){
		network *net;
		ablib::string url = g_setting.GetURL();
		if(url.find(_T("http://")) == 0){
			url.erase(0,7);//7 = ::lstrlen(_T("http://"));
			ablib::string::size_type s = url.find(_T("/"));
			m_server = url.substr(0,s);
			ablib::string proxy;
			if(::lstrcmp(dll.dllfunc<const TCHAR*>(_T("GETPROXY")),_T("")) != 0 && dll.dllfunc<int>(_T("GETPORT")) != 0){
				proxy = dll.dllfunc<const TCHAR*>(_T("GETPROXY"));
				proxy += _T(":") + boost::lexical_cast<ablib::string>(dll.dllfunc<int>(_T("GETPORT")));
			}
			net = new HTTP(m_server.c_str(),proxy.c_str());
			url.erase(0,s);
			m_curdir = url;
		}else if(url.find(_T("ftp://")) == 0){
			url.erase(0,6);//6 = ::lstrlen(_T("ftp://"));
			ablib::string::size_type s = url.find(_T("/"));
			m_server = url.substr(0,s);
			ablib::string proxy;
/*
			if(g_setting.GetProxy() != _T("") && g_setting.GetProxyPort() != 0){
				proxy = g_setting.GetProxy();
				proxy += _T(":") + boost::lexical_cast<ablib::string>(g_setting.GetProxyPort());
			}
*/
			net = new FTP(m_server.c_str(),proxy.c_str());
			url.erase(0,s);
			m_curdir = url;
		}else{
			g_setting.Log(_T("mȂvgRłD"));
			return false;
		}
		try{
			m_issuccess = GetFromNetwork(net,parent);
			delete net;
			return m_issuccess;
		}
		catch(load_function l){
			g_setting.Log(_T("֐") + l.funcname() + _T("̃[hɎsD"));
			delete net;
			return false;
		}
	}else{
		try{
			m_issuccess = GetFromLocal(parent);
			return m_issuccess;
		}
		catch(load_function l){
			g_setting.Log(_T("֐") + l.funcname() + _T("̃[hɎsD"));
			return false;
		}
	}
}

bool GetInfo::GetFromLocal(HWND parent){
	DLL dll;dll.loaddll();
	m_defaultinstall = (::GetFileAttributes((ablib::string(dll.dllfunc<const TCHAR*>(_T("GETHOZONDIR"))) + _T("ispell.tar.xz")).c_str()) != -1);
	m_url = _T("");
	return true;
}

bool GetInfo::Cancel(){
	g_setting.Log(_T("LZ܂D"));
	AddMsg(_T("LZ܂D"));
	return false;
}
bool GetInfo::Error(const ablib::string &log){
	g_setting.Log(log);
	AddMsg(_T("s"));
	return false;
}


bool GetInfo::GetFromNetwork(network *net,HWND parent){
	DLL dll;
	if(!dll.loaddll())return Error(_T("{̂̃[hɎsD"));
	AddMsg(m_server + _T("ɐڑcc"));
	if(!net->Connect())return Error(m_server + _T("ւ̐ڑɎsD"));
	else AddMsg(_T("\r\nfBNg̈ړcc"));
	if(CheckCancel())return Cancel();
	if(!net->SetCurDir(m_curdir.c_str()))return Error(_T("JgfBNg̈ړɎsD"));
	else AddMsg(_T("\r\nt@Cꗗ̎擾cc"));
	if(CheckCancel())return Cancel();
	std::vector<FileData> files;
	if(!net->GetFileList(files))return Error(_T("t@CXg̎擾ɎsD"));
	else AddMsg(_T("\r\nt@C̎擾cc"));
	if(CheckCancel())return Cancel();
	std::vector<FileData> ispells;

	int reghandle = dll.dllfunc<int>(_T("REGEX_COMPILE"),_T("ispell.*-w32\\.tar\\.xz"));
	for(FileData &i : files){
		DEBUGSTRING(_T("%s"),i.file.c_str());
		if(dll.dllfunc<bool>(_T("REGEX_MATCH"),reghandle,i.file.c_str()))ispells.push_back(i);
	}
	FileData file = GetLatest(ispells);
	AddMsg(_T("\r\nؒf"));
	if(CheckCancel())return Cancel();

	ablib::system::Time localtime = ablib::system::File::GetLastWriteTime(ablib::string(dll.dllfunc<const TCHAR*>(_T("GETHOZONDIR"))) + _T("ispell.tar.xz"));
	m_defaultinstall = (file.time > localtime);
	m_size = file.size;

	m_url = net->GetProtocol() + _T("://") + m_server + m_curdir + file.file;
	return true;
}
	

GetInfo::FileData GetInfo::GetLatest(const std::vector<FileData> &files){
	if(files.empty())return FileData();
	std::vector<int> versions;
	for(const FileData &i : files){
		ablib::string ver;
		ver.reserve(i.file.length());
		for(ablib::string::size_type j = 0 ; j < i.file.length() ; ++j){
			if('0' <= i.file[j] && i.file[j] <= '9')ver += i.file[j];
#ifndef UNICODE
			else if(ablib::IsKanji(i.file[j]))++j;
#endif
		}
		versions.push_back(boost::lexical_cast<int>(ver));
	}
	FileData rv;
	rv = files[std::max_element(versions.begin(),versions.end()) - versions.begin()];
	return rv;
}

bool GetInfo::HTTP::GetFileListFromIndexHtml(std::vector<GetInfo::FileData> &fds,const ablib::string &str){
	DLL dll;
	if(!dll.loaddll()){
		g_setting.Log(_T("{̂̃[hɎsD"));
		return false;
	}
	// 0: t@CC1: C2: C3: NC4: C5: C6: TCY
	int handle = dll.dllfunc<int>(_T("REGEX_COMPILE"),_T("href[ \\t]*=[ \\t]*\"([^\\n\\r\"]+)\"[^\\n\\r]*?([0-9]*)-([A-Za-z]*)-([0-9]*)[ \\t]*([0-9]*):([0-9]*)[^\\n\\r]*?([0-9\\\\.]*[KMB])"));
	ablib::string::size_type p = 0;
	FileData fd;
	while(dll.dllfunc<bool>(_T("REGEX_MATCH"),handle,str.c_str() + p)){
		fd.file = dll.dllfunc<const TCHAR*>(_T("REGEX_GETMATCHSTR"),handle,1);
		fd.size = FromStrSize2IntSize(dll.dllfunc<const TCHAR*>(_T("REGEX_GETMATCHSTR"),handle,7));

		ablib::string day = dll.dllfunc<const TCHAR*>(_T("REGEX_GETMATCHSTR"),handle,2);
		ablib::string month = dll.dllfunc<const TCHAR*>(_T("REGEX_GETMATCHSTR"),handle,3);
		ablib::string year = dll.dllfunc<const TCHAR*>(_T("REGEX_GETMATCHSTR"),handle,4);
		ablib::string hour = dll.dllfunc<const TCHAR*>(_T("REGEX_GETMATCHSTR"),handle,5);
		ablib::string min = dll.dllfunc<const TCHAR*>(_T("REGEX_GETMATCHSTR"),handle,6);
		DWORD m = FromStrMonth2IntMonth(month);

		ablib::system::Time time(
			boost::lexical_cast<int>(year),
			m,
			boost::lexical_cast<int>(day),
			boost::lexical_cast<int>(hour),
			boost::lexical_cast<int>(min));
		fd.time = time;
		fds.push_back(fd);
		p += dll.dllfunc<int>(_T("REGEX_GETMATCHPOS"),handle) + dll.dllfunc<int>(_T("REGEX_GETMATCHLEN"),handle);
	}
	return true;
}

DWORD GetInfo::HTTP::FromStrMonth2IntMonth(const ablib::string &month){
	if(month == _T("Jan"))return 1;
	else if(month == _T("Feb"))return 2;
	else if(month == _T("Mar"))return 3;
	else if(month == _T("Apr"))return 4;
	else if(month == _T("May"))return 5;
	else if(month == _T("Jun"))return 6;
	else if(month == _T("Jul"))return 7;
	else if(month == _T("Aug"))return 8;
	else if(month == _T("Sep"))return 9;
	else if(month == _T("Oct"))return 10;
	else if(month == _T("Nov"))return 11;
	else if(month == _T("Dec"))return 12;
	else g_setting.Log(_T("ϊŃ~XDoOۂ炠ׂ̂ɕ傢ƂāDmonth = ") + month);
	return -1;
}

int GetInfo::HTTP::FromStrSize2IntSize(const ablib::string &s){
	if(s == _T(""))return 0;
	char c = s[s.length() - 1];
	double size;
	if(!('0' <= c && c <= '9'))size = ::atof(s.c_str());
	else size = ::atof(s.substr(0,s.length() - 1).c_str());
	switch(c){
	case 'M':
		size = size*1024*1024;
		break;
	case 'K':
		size = size*1024;
	default:
		size = size;
	}
	return static_cast<int>(size);
}

