#ifndef __STDAFX_H__
#define __STDAFX_H__

#include <windows.h>
#include <tchar.h>
#include <wininet.h>

#ifdef __cplusplus
#define EXPORT extern "C" __declspec(dllexport)
#else
#define EXPORT __declspec(dllexport)
#endif //__cplusplus

//string^͑RgD
#include <ablib/string.h>

//Rs[֎~I
#define NOCOPY(T) T( const T& ); T& operator=( const T& )

//[
#ifndef __ABENORI_ASSERT__
	#ifdef NDEBUG
		#define ASSERT(C)
	#else
		#include <assert.h>
		#define ASSERT(C) assert(C)
	#endif
#endif

//ł΂p
#ifndef __DEBUGSTRING__
	#define __DEBUGSTRING__
	#ifdef NDEBUG
		inline void DEBUGSTRING(const TCHAR *fmt,...){}
	#else
		#include <stdarg.h>
		#include <stdio.h>
		inline void DEBUGSTRING(const TCHAR *fmt,...){
			TCHAR buf[4096];
			va_list args;
			va_start(args,fmt);
			::vsprintf(buf,fmt,args);
			::OutputDebugString(buf);
			::OutputDebugString(_T("\n"));
			va_end(args);
		}
	#endif
#endif

#endif //__STDAFX_H__

