#include "stdafx.h"
#include "setting.h"
#include <stdio.h>

/* ݒt@C
[jsclasses]
URL=ijsclasses̃y[Wj
target=iCXg[texmfc[j
*/

void setting::SetINIFile(const TCHAR *ini,const TCHAR *log){
	m_ini = ini;
	m_log = log;
	SetURL(GetINIStr(_T("jsclasses"),_T("URL")));
	if(GetURL() == _T(""))SetURL(_T("http://oku.edu.mie-u.ac.jp/~okumura/jsclasses/"));
	SetTargetDir(GetINIStr(_T("jsclasses"),_T("target")));
	if(GetTargetDir() == _T(""))SetTargetDir(_T("share\\texmf-local\\"));
}

void setting::Log(const ablib::string &log){
	LOCK l(this);
	FILE *fp = ::_tfopen(m_log.c_str(),_T("a+"));
	if(fp){
		::_ftprintf(fp,_T("%s\n"),log.c_str());
		::fclose(fp);
	}
}

void setting::SetTargetDir(const ablib::string &dir){
	m_targetdir = dir;
	if(m_targetdir != _T("") && m_targetdir[m_targetdir.length() - 1] != '\\')m_targetdir += _T("\\");
	if(m_targetdir[0] == '\\')m_targetdir.erase(0,1);
}

void setting::Write(){
	WriteINIStr(_T("jsclasses"),_T("URL"),m_url);
	WriteINIStr(_T("jsclasses"),_T("target"),m_targetdir);
}

void setting::WriteINIStr(const TCHAR *sec,const TCHAR *key,const ablib::string &str){
	::WritePrivateProfileString(sec,key,str.c_str(),m_ini.c_str());
}

ablib::string setting::GetINIStr(const TCHAR *sec,const TCHAR *key){
	TCHAR buf[4096];
	::GetPrivateProfileString(sec,key,_T(""),buf,4095,m_ini.c_str());
	return ablib::string(buf);
}

int setting::GetINIInt(const TCHAR *sec,const TCHAR *key){
	return ::GetPrivateProfileInt(sec,key,0,m_ini.c_str());
}

