#include "stdafx.h"
#include "setting.h"
#include <stdio.h>

/* ݒt@C
[Xy-pic]
URL=iXy-pic̃y[Wj
target=iCXg[texmfc[j
*/

void setting::SetINIFile(const TCHAR *ini,const TCHAR *log){
	m_ini = ini;
	m_log = log;
	if(GetURL() == _T(""))WriteURL(_T("http://www.ms.u-tokyo.ac.jp/~abenori/mycreate/index.html"));
	if(GetTargetDir() == _T(""))WriteTargetDir(_T("share\\texmf-local\\"));
}

void setting::Log(const ablib::string &log){
	LOCK l(this);
	FILE *fp = ::_tfopen(m_log.c_str(),_T("a+"));
	if(fp){
		::_ftprintf(fp,_T("%s\n"),log.c_str());
		::fclose(fp);
	}
}

void setting::WriteURL(const TCHAR *url){
	WriteINIStr(_T("Xy-pic"),_T("URL"),url);
}

void setting::WriteTargetDir(const TCHAR *dir){
	ablib::string d = dir;
	if(d != _T("") && d[d.length() - 1] != '\\')d += _T("\\");
	if(d[0] == '\\')d.erase(0,1);
	WriteINIStr(_T("Xy-pic"),_T("target"),d.c_str());
}


void setting::WriteINIStr(const TCHAR *sec,const TCHAR *key,const TCHAR *str){
	::WritePrivateProfileString(sec,key,str,m_ini.c_str());
}

ablib::string setting::GetINIStr(const TCHAR *sec,const TCHAR *key){
	TCHAR buf[4096];
	::GetPrivateProfileString(sec,key,_T(""),buf,4095,m_ini.c_str());
	return ablib::string(buf);
}

int setting::GetINIInt(const TCHAR *sec,const TCHAR *key){
	return ::GetPrivateProfileInt(sec,key,0,m_ini.c_str());
}

